#include <iostream>

#include <queue>
const uint32_t MAX_N = 202;
const uint32_t INF = 1e9;

//
uint32_t dp[2][MAX_N][MAX_N];
uint32_t deg[2][MAX_N][MAX_N];

struct S {
	uint32_t a, i, j;
	S(uint32_t a = 0, uint32_t i= 0, uint32_t j =0): a(a), i(i), j(j) {}
};

void calc_dp(uint32_t n, uint32_t l, uint32_t b, uint32_t k) {

	std::queue<S> next;
	for (uint32_t i = 0;i < n;i++) {
		for (uint32_t j = 0;j < n;j++) {
			dp[0][i][j] = dp[1][i][j] = 1;
			if ((i == j) && (i != 0)) {
				deg[0][i][j] = deg[1][i][j] = INF;
			} else {
				deg[0][i][j] = deg[1][i][j] = 0;
			}
		}
	}
	for (uint32_t i = 0;i < n;i++) {
		for (uint32_t j = 0;j < n;j++) {
			for (uint32_t s = 1;s <= l;s++) {
				uint32_t i1 = i + s;
				if (i1 < n) {
					deg[0][i][j]++;
				}
			}

			for (uint32_t s = 1;s <= b;s++) {
				uint32_t j1 = j + s;
				if (j1 < n) {
					deg[1][i][j]++;
				}
			}
		}
	}
	for (uint32_t i = 0;i < n;i++) {
		for (uint32_t j = 0;j < n;j++) {
		if (deg[1][i][j] == 0) {
				dp[1][i][j] = 2;
				next.push({1, i, j});
			}
			if (deg[0][i][j] == 0) {
				dp[0][i][j] = 2;
				next.push({0, i, j});
			}
		}
	}



	while (!next.empty()) {
		S cur = next.front();
		next.pop();
		std::cerr << cur.a << " " << cur.i << " " << cur.j << ": ";
		std::cerr << dp[cur.a][cur.i][cur.j] << "\n";

		if (cur.a == 0) {
			bool sw = cur.i + k == cur.j;
			for (uint32_t s = 1;s <= b;s++) {
				if (cur.j < s) {
					continue;
				}
				S s1 = {1, cur.i, cur.j - s};
				if (dp[cur.a][cur.i][cur.j] == 0) {
					dp[s1.a][s1.i][s1.j] = 2;
					next.push(s1);
					deg[s1.a][s1.i][s1.j] = INF;
				}
				deg[s1.a][s1.i][s1.j]--;
				if (deg[s1.a][s1.i][s1.j] == 0) {
					if (dp[s1.a][s1.i][s1.j] == 1) {
						dp[s1.a][s1.i][s1.j] = 0;
						next.push(s1);
						deg[s1.a][s1.i][s1.j] = INF;
					}
				}

				if (!sw) {
					continue;
				}
				s1 = {0, cur.i + k, cur.j - s};
				if (dp[cur.a][cur.i][cur.j] == 0) {
					dp[s1.a][s1.i][s1.j] = 2;
					next.push(s1);
					deg[s1.a][s1.i][s1.j] = INF;
				}
				deg[s1.a][s1.i][s1.j]--;
				if (deg[s1.a][s1.i][s1.j] == 0) {
					if (dp[s1.a][s1.i][s1.j] == 1) {
						dp[s1.a][s1.i][s1.j] = 0;
						next.push(s1);
						deg[s1.a][s1.i][s1.j] = INF;
					}
				}
			}
		} else {
			bool sw = cur.j + k == cur.i;
			for (uint32_t s = 1;s <= l;s++) {
				if (cur.i < s) {
					continue;
				}
				S s1 = {0, cur.i - s, cur.j};
				if (dp[cur.a][cur.i][cur.j] == 0) {
					dp[s1.a][s1.i][s1.j] = 2;
					next.push(s1);
					deg[s1.a][s1.i][s1.j] = INF;
				}
				deg[s1.a][s1.i][s1.j]--;
				if (deg[s1.a][s1.i][s1.j] == 0) {
					if (dp[s1.a][s1.i][s1.j] == 1) {
						dp[s1.a][s1.i][s1.j] = 0;
						next.push(s1);
						deg[s1.a][s1.i][s1.j] = INF;
					}
				}

				if (!sw) {
					continue;
				}
				s1 = {0, cur.i - s, cur.j + k};
				if (dp[cur.a][cur.i][cur.j] == 0) {
					dp[s1.a][s1.i][s1.j] = 2;
					next.push(s1);
					deg[s1.a][s1.i][s1.j] = INF;
				}
				deg[s1.a][s1.i][s1.j]--;
				if (deg[s1.a][s1.i][s1.j] == 0) {
					if (dp[s1.a][s1.i][s1.j] == 1) {
						dp[s1.a][s1.i][s1.j] = 0;
						next.push(s1);
						deg[s1.a][s1.i][s1.j] = INF;
					}
				}
			}

		}
	}
	std::cerr << "-------------\n";
}

int main() {
	uint32_t tCnt;
	std::cin >> tCnt;
	for (uint32_t i = 0;i < tCnt;i++) {
		uint32_t n, l, b, k;
		std::cin >> n >> l >> b >> k;
		calc_dp(n, l, b, k);
		if (dp[0][0][0] == 2) {
			std::cout << "Lora\n";
		} else if (dp[0][0][0] == 1) {
			std::cout << "Draw\n";
		} else{ 
			std::cout << "Bobi\n";
		}
	}
}


