#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 10);
const int OFFSET = (1 << 10);

struct min_cut
{
	struct edge
	{
		int to, cap, flow, rev;
		edge() { to = cap = flow = 0; }
		edge(int t, int r, int c, int f)
		{
			to = t;
			rev = r;
			cap = c;
			flow = f;
		}
	};

	int n;
	vector<edge> G[MAXN];

	void init(int _n)
	{
		n = _n;
		for(int i = 0; i <= n; i++)
			G[i].clear();
	}

	void add_edge(int u, int v, int w)
	{
		G[u].pb(edge(v, SZ(G[v]), w, 0));
		G[v].pb(edge(u, SZ(G[u]) - 1, 0, 0));
	}

	void add_dep(int u, int v, int w)
	{
		G[u].pb(edge(v, SZ(G[v]), w, 0));
		G[v].pb(edge(u, SZ(G[u]) - 1, w, 0));
	}

	int po[MAXN], d[MAXN];

	bool bfs(int s, int t)
	{
		for(int i = 0; i <= n; i++)
			po[i] = 0, d[i] = -1;

		queue<int> q;
		q.push(s);
		d[s] = 0;

		while(!q.empty())
		{
			int u = q.front();
			q.pop();

			for(auto e: G[u])
				if(e.cap > e.flow && d[e.to] == -1)
				{
					d[e.to] = d[u] + 1;
					q.push(e.to);
				}
		}

		return d[t] != -1;
	}

	int dfs(int u, int t, int f)
	{
		if(u == t)
			return f;

		//for(; po[u] < SZ(G[u]); )
		for(int idx = po[u]; idx < SZ(G[u]); idx++)
		{
			if(G[u][idx].flow == G[u][idx].cap || (d[u] + 1 != d[G[u][idx].to]))
				po[u]++;

			if(G[u][idx].flow < G[u][idx].cap && (d[u] + 1 == d[G[u][idx].to]))
			{
				int fl = dfs(G[u][idx].to, t, min(f, G[u][idx].cap - G[u][idx].flow));

				G[u][idx].flow += fl;
				G[G[u][idx].to][G[u][idx].rev].flow -= fl;

				if(fl > 0)
					return fl;
			}
		}

		d[u] = (int)1e9;
		return 0;
	}

    int flow(int s, int t)
    {
		int ans = 0, to_add;
		while(bfs(s, t))
		{
			while((to_add = dfs(s, t, (int)1e9)))
				ans += to_add;
		}

		return ans;
    }
};

int n, m;
int a[MAXN], b[MAXN];
int sum_all = 0;

min_cut initial;
int S, T;
pair<int, int> ed[MAXN << 10];
int c_ed[MAXN << 10];

void read()
{
	cin >> n >> m;



	for(int i = 1; i <= n; i++)
		cin >> a[i];
	for(int i = 1; i <= n; i++)
		cin >> b[i];

	for(int i = 0; i < m; i++)
	{
		int u, v, c;
		cin >> u >> v >> c;
		initial.add_dep(u, v, c);
		ed[i] = {u, v};
		c_ed[i] = c;
	}
}

bool is_in[MAXN];

int solve_curr()
{
	sum_all = 0;

	initial.init(n + 2);
	S = n + 1;
	T = n + 2;

	for(int i = 1; i <= n; i++)
		if(is_in[i])
		{
			sum_all += a[i];
			sum_all += b[i];

			initial.add_edge(S, i, a[i]);
			initial.add_edge(i, T, b[i]);
		}

	for(int i = 0; i < m; i++)
	{
		int u = ed[i].first, v = ed[i].second, c = c_ed[i];
		if(is_in[u] && is_in[v])
			initial.add_dep(u, v, c);
	}

	return sum_all - initial.flow(S, T);
}

void solve()
{
	for(int i = 1; i <= n; i++)
		is_in[i] = 1;

	cout << solve_curr() << endl;

	int q;
	cin >> q;
	while(q--)
	{
		int type;
		cin >> type;

		if(type == 1 || type == 2)
		{
			int u;
			cin >> u;
			is_in[u] ^= 1;
		}

		if(type == 3)
		{
			for(int i = 1; i <= n; i++)
				is_in[i] = 1;
		}

		if(type == 4)
		{
			for(int i = 1; i <= n / 5; i++)
				is_in[i] = 0;
		}

		if(type != 3 && type != 4)
			cout << solve_curr() << endl;
	}
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
