#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <queue>
#include <cassert>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 4e3 + 15;
const int INF = 1e9;

int n, m, Q;
int good[N], bad[N];

vector <pair <int, int> > nb[N];
int e[N][N];
int vis[N], timestamp;

int s, t;
int f[N][N], c[N][N];

bool killed[2 * N];

void do_thingy(int v)
{
    c[v][v + n] = INF;
    f[v][v + n] = 0;

    c[v + n][v] = 0;
    f[v + n][v] = 0;

    c[s][v] = good[v];
    f[s][v] = 0;

    c[v][s] = 0;
    f[v][s] = 0;

    c[v + n][t] = bad[v];
    f[v + n][t] = 0;

    c[t][v + n] = 0;
    f[t][v + n] = 0;

    for(auto x: nb[v])
    {
        int u = x.first;
        int w = x.second;

        c[v][u + n] = w;
        f[v][u + n] = 0;

        c[u + n][v] = 0;
        f[u + n][v] = 0;

        c[u][v + n] = w;
        f[u][v + n] = 0;

        c[v + n][u] = 0;
        f[v + n][u] = 0;
    }
}

void add_edges(int v)
{
    killed[v] = false;
    killed[v + n] = false;

    for(int i = 1; i <= (2 * n) + 2; i++)
    {
        f[i][v] = f[v][i] = 0;
        f[i][v + n] = f[v + n][i] = 0;
    }

}

void rmv_edges(int v)
{
    killed[v] = true;
    killed[v + n] = true;
}

vector <int> real_nb[N];
int pred[N];

int flow;
queue <int> q;
bool BFS()
{
    while(!q.empty())
        q.pop();

    timestamp++;

    q.push(s);
    vis[s] = timestamp;

    while(!q.empty() && (vis[t] < timestamp))
    {
        int v = q.front();
        q.pop();

        for(int u: real_nb[v])
        {
            if(killed[u])
            {
                //cerr << v << " " << u << " KILLED" << endl;
                continue;
            }

            if(vis[u] < timestamp && (c[v][u] - f[v][u] > 0))
            {
                q.push(u);
                vis[u] = timestamp;
                pred[u] = v;
            }
        }
    }

    return (vis[t] == timestamp);
}


void update_flow()
{
    int fmin = INF;

    int v = t;
    while(v != s)
    {
        int u = pred[v];
        fmin = min(fmin, c[u][v] - f[u][v]);

        v = u;
    }

    v = t;
    while(v != s)
    {
        int u = pred[v];
        f[u][v] += fmin;
        f[v][u] -= fmin;

        v = u;
    }

    flow += fmin;
}

int sum_all;

void revive_all()
{
    for(int i = 1; i <= n; i++)
    {
        if(killed[i])
          add_edges(i);
    }

    while(BFS())
      update_flow();
}

void kill_fifth()
{
    for(int i = 1; i <= n / 5; i++)
    {
        if(!killed[i])
            rmv_edges(i);
    }

    flow = 0;
    while(BFS())
      update_flow();
}

int sum_alive()
{
    int res = 0;
    for(int i = 1; i <= n; i++)
        if(!killed[i])
            res += good[i] + bad[i];

    return res;
}

int uu[N], vv[N], xx[N];
void rebuild_network()
{
    int u, v, x;

    for(int i = 1; i <= 2 * n + 2; i++)
        {
            nb[i].clear();
            real_nb[i].clear();
        }

    for(int i = 1; i <= m; i++)
    {
        u = uu[i];
        v = vv[i];
        x = xx[i];

        if(killed[u] || killed[v])
          continue;

        nb[u].pb({v, x});
        nb[v].pb({u, x});

        real_nb[u].pb(v + n);
        real_nb[v].pb(u + n);
    }

    for(int i = 1; i <= n; i++)
    {
        if(killed[i])
            continue;

        real_nb[s].pb(i);
        real_nb[i + n].pb(t);
        real_nb[i].pb(i + n);
    }

    for(int i = 1; i <= n; i++)
        do_thingy(i);
}


void print_flow(int v)
{
    cerr << "BEGIN FLOW PRINT" << endl;
    for(int i = 1; i <= 2 * n + 2; i++)
    {
        cerr << f[i][v] << " " << f[v][i] << endl;
    }
    cerr << "END FLOW PRINT" << endl;

}

void all_flow()
{
    cerr << "ALL FLOW" << endl;
    for(int i = 1; i <= n; i++)
    {
        cerr << f[s][i] << " " << f[i + n][t] << endl;
        cerr << c[s][i] << " " << c[i + n][t] << endl;
        cerr << endl;
    }
    cerr << "END ALL FLOW" << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int type, u, v, x;

    cin >> n >> m;
    s = (2 * n) + 1; t = (2 * n) + 2;

    for(int i = 1; i <= n; i++)
        cin >> good[i];
    for(int i = 1; i <= n; i++)
        cin >> bad[i];

    for(int i = 1; i <= m; i++)
    {
        cin >> u >> v >> x;
        uu[i] = u;
        vv[i] = v;
        xx[i] = x;

        e[u][v] = e[v][u] = x;

        nb[u].pb({v, x});
        nb[v].pb({u, x});

        real_nb[u].pb(v + n);
        real_nb[v].pb(u + n);
    }
    cin >> Q;

    for(int i = 1; i <= n; i++)
    {
        real_nb[s].pb(i);
        real_nb[i + n].pb(t);
        real_nb[i].pb(i + n);
    }

    for(int i = 1; i <= n; i++)
        do_thingy(i);

    while(BFS())
        update_flow();

    cout << sum_alive() - flow << endl;

   // cerr << sum_alive() << " SUM ALIVE" << endl;
   // cerr << flow << " FLOW" << endl;

   // all_flow();

    for(int ii = 1; ii <= Q; ii++)
    {
        //all_flow();

        cin >> type;

        if(type == 1)
        {
            cin >> v;
            add_edges(v);

            flow = 0;
            for(int i = 1; i <= 2 * n + 2; i++)
                for(int j = 1; j <= 2 * n + 2; j++)
                    f[i][j] = 0;
            while(BFS())
                update_flow();

            cout << sum_alive() - flow << endl;
        }

        if(type == 2)
        {
            cin >> v;
            rmv_edges(v);

            flow = 0;
            for(int i = 1; i <= 2 * n + 2; i++)
                for(int j = 1; j <= 2 * n + 2; j++)
                    f[i][j] = 0;

            while(BFS())
                update_flow();

            cout << sum_alive() - flow << endl;
        }

        if(type == 3)
        {
            revive_all();
        }

        if(type == 4)
        {
            kill_fifth();
        }

      //  cerr << sum_alive() << " SUM ALIVE" << endl;
      //  cerr << flow << " FLOW " << endl;
    }


    return 0;
}


/*

5 4
10 15 22 20 31
10 14 10 25 31
1 4 10
2 4 10
1 3 2
4 5 10
7
2 5
2 4
1 4
2 1
3
4
2 5

*/


/*

4 3
10 15 22 20
10 14 10 25
1 4 10
2 4 10
1 3 2
0

*/

/*

5 4
10 15 22 20 31
10 14 10 25 31
1 4 10
2 4 10
1 3 2
4 5 10
1
2 5

*/

/*

  /*  c[s][v] = 0;
    c[v + n][t] = 0;
    for(int i = 1; i <= 2 * n + 2; i++)
    {
        c[i][v] = c[v][i] = 0;
        f[i][v] = f[v][i] = 0;

        c[i][v + n] = c[v + n][i] = 0;
        f[i][v + n] = f[v + n][i] = 0;
    } */

   /* c[v][v + n] = 0;
    f[v][v + n] = 0;

    c[s][v] = 0;
    f[s][v] = 0;

    c[v][s] = 0;
    f[v][s] = 0;

    c[v + n][t] = 0;
    f[v + n][t] = 0;

    c[t][v + n] = 0;
    f[t][v + n] = 0;

    for(auto x: nb[v])
    {
        int u = x.first;
        int w = x.second;

        c[v][u + n] = 0;
        f[v][u + n] = 0;

        c[u + n][v] = 0;
        f[u + n][v] = 0;

        c[u][v + n] = 0;
        f[u][v + n] = 0;

        c[v + n][u] = 0;
        f[v + n][u] = 0;
    }

*/
