#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int MAXN = 1005;

struct edge
{
    int u, v, w;
    edge(){}
    edge(int u, int v, int w)
    {
        this -> u = u;
        this -> v = v;
        this -> w = w;
    }
};

int n, m, q;
int a[MAXN], b[MAXN];
vector<pair<int, int>> g[MAXN];
vector<edge> friendships;
bool part[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
        friendships.emplace_back(u, v, w);
    }

    for (int i = 1; i <= n; ++ i)
    {
        part[i] = 1;
    }
}

void Answer()
{
    int opt = 0;
    for (int i = 0; i < (1 << n); ++ i)
    {
        int ans = 0;
        for (int j = 1; j <= n; ++ j)
        {
            if (part[j] == 0) continue;

            if (i & (1 << (j - 1))) ans += a[j];
            else ans += b[j];
        }

        for (int j = 0; j < friendships.size(); ++ j)
        {
            if (part[friendships[j].u] == 0 or part[friendships[j].v] == 0) continue;

            int t1 = i & (1 << (friendships[j].u - 1));
            int t2 = i & (1 << (friendships[j].v - 1));
            if ((t1 != 0 and t2 == 0) or (t1 == 0 and t2 != 0)) ans -= friendships[j].w;
        }

        opt = max(opt, ans);
    }
    cout << opt << endl;
}

int main()
{
    Init();

    Answer();

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int x;
            cin >> x;
            part[x] = 1;
            Answer();
        }
        if (t == 2)
        {
            int x;
            cin >> x;
            part[x] = 0;
            Answer();
        }
        if (t == 3)
        {
            for (int i = 1; i <= n; ++ i)
            {
                part[i] = 1;
            }
        }
        if (t == 4)
        {
            for (int i = 1; i <= n / 5; ++ i)
            {
                part[i] = 0;
            }
        }
    }
}
