#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int MAXN = 1005;

struct edge
{
    int u, v, w;
    edge(){}
    edge(int u, int v, int w)
    {
        this -> u = u;
        this -> v = v;
        this -> w = w;
    }
};

int n, m, q;
int a[MAXN], b[MAXN];
vector<pair<int, int>> g[MAXN];
vector<edge> friendships;
bool part[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
        friendships.emplace_back(u, v, w);
    }

    for (int i = 1; i <= n; ++ i)
    {
        part[i] = 1;
    }
}

void Answer()
{
    int opt = 0;
    for (int i = 0; i < (1 << n); ++ i)
    {
        int ans = 0;
        for (int j = 1; j <= n; ++ j)
        {
            if (part[j] == 0) continue;

            if (i & (1 << (j - 1))) ans += a[j];
            else ans += b[j];
        }

        for (int j = 0; j < friendships.size(); ++ j)
        {
            if (part[friendships[j].u] == 0 or part[friendships[j].v] == 0) continue;

            int t1 = i & (1 << (friendships[j].u - 1));
            int t2 = i & (1 << (friendships[j].v - 1));
            if ((t1 != 0 and t2 == 0) or (t1 == 0 and t2 != 0)) ans -= friendships[j].w;
        }

        opt = max(opt, ans);
    }
    cout << opt << endl;
}

int group[MAXN][2];
int vis[MAXN];

void DFS(int u = 1, int p = -1)
{
    if (vis[u] != 0) return;
    else vis[u] = 1;

    group[u][0] = a[u];
    group[u][1] = b[u];

    for (auto adj : g[u])
    {
        DFS(adj.first, u);
    }

    for (auto adj : g[u])
    {
        if (adj.first == p) continue;

        int v = adj.first;
        int w = adj.second;

        group[u][0] += max(group[v][0], group[v][1] - w);
        group[u][1] += max(group[v][1], group[v][0] - w);
    }
}

int main()
{
    Init();

    cin >> q;
    if (q == 0)
    {
        DFS();
        cout << max(group[1][0], group[1][1]) << endl;
        return 0;
    }

    Answer();

    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int x;
            cin >> x;
            part[x] = 1;
            Answer();
        }
        if (t == 2)
        {
            int x;
            cin >> x;
            part[x] = 0;
            Answer();
        }
        if (t == 3)
        {
            for (int i = 1; i <= n; ++ i)
            {
                part[i] = 1;
            }
        }
        if (t == 4)
        {
            for (int i = 1; i <= n / 5; ++ i)
            {
                part[i] = 0;
            }
        }
    }
}

/*
5 4
10 15 22 20 31
10 14 10 25 31
1 4 10
2 4 10
1 3 2
4 5 10
0
*/
