#pragma GCC optimize "Ofast"
#include <iostream>

const int MAX_N = 10000 + 10;
int n, m;

int good[MAX_N], bad[MAX_N];
int mat[MAX_N][MAX_N];
int type[MAX_N]; // 0-unk, 1-good, 2-bad

const int othertype[3] = {0, 2, 1};

int PR(int x) {
	if(type[x] == 1) return good[x];
	if(type[x] == 2) return bad[x];
	std::cerr << "WTF PR ERR" << std::endl;
	return 0;
}

void greedy() {
	for(int i = 1;i <= n;i ++) {
		if(good[i] > bad[i]) type[i] = 1;
		else type[i] = 2;
	}
}

bool optimize() {
	for(int i = 1;i <= n;i ++) {
		int curr = PR(i);
		for(int j = 1;j <= n;j ++) {
			if(type[j] != type[i]) curr -= mat[i][j];
		}

		type[i] = othertype[type[i]];
		int pnew = PR(i);
		for(int j = 1;j <= n;j ++) {
			if(type[j] != type[i]) pnew -= mat[i][j];
		}

		if(pnew <= curr) {
			type[i] = othertype[type[i]];
		} else {
			//std::cerr << "optimized " << i << ' ' << type[i] << ' ' << pnew << ' ' << curr << std::endl;
			return true;
		}
	}
	return false;
}

void query(int t, int idx) {
}

int compAns() {
	int ans = 0;
	for(int i = 1;i <= n;i ++) {
		int curr = PR(i);
		for(int j = 1;j <= n;j ++) {
			if(type[i] == 1 and type[j] != type[i]) curr -= mat[i][j];
		}
		//std::cout << "ca " << i << ' ' << curr << std::endl;
		ans += curr;
	}
	return ans;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m;
	for(int i = 0;i < n;i ++) std::cin >> good[i+1];
	for(int i = 0;i < n;i ++) std::cin >> bad[i+1];

	for(int i = 0;i < m;i ++) {
		int a, b, c;
		std::cin >> a >> b >> c;
		mat[a][b] = c;
		mat[b][a] = c;
	}

	greedy();
	while(optimize()) {}
	/*
	for(int j = 1;j <= n;j ++) {
		std::cout << j << ' ' << type[j] << std::endl;
	}
	*/

	std::cout << compAns() << '\n';

	int q;
	std::cin >> q;
	for(int i = 0;i < q;i ++) {
		int t;
		std::cin >> t;
		if(t == 1 or t == 2) {
			int x;
			std::cin >> x;
			query(t, x);
		} else {
			query(t, -1);
		}
		std::cout << compAns() << '\n';
	}
	return 0;
}
