#pragma GCC optimize "Ofast"
#include <iostream>
#include <bitset>

const int MAX_N = 10000 + 10;
int n, m;

int good[MAX_N], bad[MAX_N];
int mat[MAX_N][MAX_N];
int type[MAX_N]; // 0-unk, 1-good, 2-bad
bool left[MAX_N];

const int othertype[3] = {0, 2, 1};

int PR(int x) {
	if(type[x] == 1) return good[x];
	if(type[x] == 2) return bad[x];
	std::cerr << "WTF PR ERR" << std::endl;
	return 0;
}

int compAns() {
	int ans = 0;
	for(int i = 1;i <= n;i ++) {
		if(left[i]) continue;
		int curr = PR(i);
		for(int j = 1;j <= n;j ++) {
			if(left[j]) continue;
			if(type[i] == 1 and type[j] != type[i]) curr -= mat[i][j];
		}
		//std::cout << "ca " << i << ' ' << curr << std::endl;
		ans += curr;
	}
	return ans;
}


int ANS;

void bf() {
	/*
	std::cout << "===============" << std::endl;
	for(int i = 0;i < n;i ++) {
		std::cout << "L " << i << ' ' << left[i] << std::endl;
	}
	*/

	int bits[MAX_N];
	int bestAns = -(1 << 30);
	// TODO ignore left
	for(int conf = 0;conf < (1 << n);conf ++) {
		{
		int cp = conf;
		for(int i = 0;i < n;i ++) {
			bits[i] = cp % 2;
			cp /= 2;
		}
		}
		for(int i = 1;i <= n;i ++) type[i] = 1 + bits[i-1];
		int ans = compAns();
		if(ans > bestAns) {
			bestAns = ans;
		}
		//std::cout << std::endl;
	}
	ANS = bestAns;
}

void query(int t, int idx) {
	//std::cout << "q " << t << std::endl;

	if(t == 2) left[idx] = true;
	if(t == 1) left[idx] = false;
	if(t == 3) std::fill(left+1, left+n+1, false);
	if(t == 4) std::fill(left+1, left+n/5+1, true);

	if(t == 2 or t == 1) bf();
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m;
	for(int i = 0;i < n;i ++) std::cin >> good[i+1];
	for(int i = 0;i < n;i ++) std::cin >> bad[i+1];

	for(int i = 0;i < m;i ++) {
		int a, b, c;
		std::cin >> a >> b >> c;
		mat[a][b] = c;
		mat[b][a] = c;
	}

	bf();

	std::cout << ANS << '\n';

	int q;
	std::cin >> q;
	for(int i = 0;i < q;i ++) {
		int t;
		std::cin >> t;
		if(t == 1 or t == 2) {
			int x;
			std::cin >> x;
			query(t, x);
			std::cout << ANS << '\n';
		} else {
			query(t, -1);
		}
	}
	return 0;
}
