#pragma GCC optimize "Ofast"
#include <iostream>
#include <set>

int n;

constexpr int myabs(int k) noexcept {
	return (k >= 0 ? k : -k);
}

std::set<int> nums;
std::set<int> diffs;
int l;

bool rec(int prev) {
	if(nums.size() == n) {
		std::cout << "n: " << n << std::endl;
		for(auto x : nums) {
			std::cout << x << ' ';
		}
		std::cout << "======" << std::endl;
		return true;
	}

	for(int i = prev+1;i < l;i ++) {
		if(nums.find(i) != nums.end()) continue;

		std::set<int> nd;
		bool fail = false;

		for(auto x : nums) {
			const int d = myabs(x - i);
			if(diffs.find(d) != diffs.end() or nd.find(d) != nd.end()) {
				fail = true;
				break;
			}
			nd.insert(d);
		}

		if(!fail) {
			//std::set<int> cpnums = nums;
			//std::set<int> cpdiffs = diffs;
			for(auto x : nd) { diffs.insert(x); }
			nums.insert(i);

			auto r = rec(i);
			if(r) {
				return true;
			}
			else {
				for(auto x : nd) { diffs.erase(x); }
				nums.erase(i);
			}
		}
	}

	return false;
}

void precompute() {
	const int bl = 56;
	n = 10;
	std::cout << "starting bl=" << bl << ' ' << "n=" << n << std::endl;
	for(l = bl;;l --) {
		nums = {0, l};
		diffs = {l};
		auto r = rec(0);
		if(!r) {
			std::cout << "fail " << n << ' ' << l << std::endl;
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	precompute();
	return 0;
}
