#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 1e3;
const int INF = 1e6;

struct friends
{
    int v, w, t;

    friends(int _v, int _w, int _t)
    {
        v = _v;
        w = _w;
        t = _t;
    }
};

int n, m, q;
int a[MAXN], b[MAXN];
bool out[MAXN];
vector <friends> fr;

int get_sum()
{
    int ans = -INF;
    for(int mask = (1 << (n + 1)) - 1; mask >= 0; mask--)
    {
        int sum = 0;
        for(int j = 0; j < n; j++)
        {
            if(out[j])
            {
                continue;
            }
            if((mask & (1 << j)) == 0)
            {
                sum += a[j];
            }
            else
            {
                sum += b[j];
            }
        }
        for(int j = 0; j < m; j++)
        {
            int v, w, t;
            v = fr[j].v; w = fr[j].w; t = fr[j].t;

            if(out[v] || out[w]) continue;

            int first = mask & (1 << v);
            if(first > 0) first = 1;
            int second = mask & (1 << w);
            if(second > 0) second = 1;
            if(first != second)
            {
                sum -= t;
            }
        }
        ans = max(sum, ans);
    }
    return ans;
}

void read_input()
{
    scanf("%d %d", &n, &m);

    for(int i = 0; i < n; i++)
    {
        scanf("%d", &a[i]);
    }
    for(int i = 0; i < n; i++)
    {
        scanf("%d", &b[i]);
    }
    int v, w, t;
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d %d", &v, &w, &t);
        v--; w--;
        fr.push_back(friends(v, w, t));
    }
}

void solve()
{
    printf("%d\n", get_sum());

    scanf("%d", &q);

    for(int z = 0; z < q; z++)
    {
        int type, pl;
        scanf("%d", &type);
        if(type == 1)
        {
            scanf("%d", &pl);
            pl--;
            out[pl] = false;
            printf("%d\n", get_sum());
        }
        else if(type == 2)
        {
            scanf("%d", &pl);
            pl--;
            out[pl] = true;
            printf("%d\n", get_sum());
        }
        else if(type == 3)
        {
            for(int i = 0; i < n; i++)
            {
                out[i] = false;
            }
        }
        else
        {
            int to = n / 5 - 1;
            for(int i = 0; i <= to; i++)
            {
                out[i] = true;
            }
        }
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
5 4
10 15 22 20 31
10 14 10 25 31
1 4 10
2 4 10
1 3 2
4 5 10
7
2 5
2 4
1 4
2 1
3
4
2 5
*/
