#include<iostream>

using namespace std;

const int MAXN = 1e3 + 5;
const int inf = 1e6 + 5;

int n, m;
int a[2][MAXN];
int edgeValue[MAXN];
pair <int, int> edge[MAXN];

bool color[MAXN];
bool active[MAXN];

int bestOption = -inf;
void rec(int node)
{
    if(node==n+1)
    {
        int sum = 0, toRemove = 0;
        for(int i = 1;i<=n;i++)
        {
            if(active[i]==false) continue;
            sum += a[ color[i] ][i];
        }
        for(int i = 0;i<m;i++)
        {
            if(active[ edge[i].first ]==false || active[ edge[i].second ]==false) continue;
            if(color[ edge[i].first ]!=color[ edge[i].second ])
            {
                toRemove += edgeValue[i];
            }
        }

        bestOption = max(bestOption, sum - toRemove);
        return;
    }

    if(active==false)
    {
        rec(node+1);
    }
    else
    {
        color[node] = false;
        rec(node+1);

        color[node] = true;
        rec(node+1);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int Q;
    int answer = 0;

    int t;
    int node;

    cin >> n >> m;
    for(int i = 1;i<=n;i++) cin >> a[0][i];
    for(int i = 1;i<=n;i++) cin >> a[1][i];
    for(int i = 0;i<m;i++)
    {
        cin >> edge[i].first >> edge[i].second;
        cin >> edgeValue[i];
    }

    for(int i = 1;i<=n;i++)
    {
        active[i] = true;
    }

    bestOption = -inf;
    rec(1);

    cout << bestOption << '\n';

    cin >> Q;
    while(Q--)
    {
        cin >> t;
        if(t==1)
        {
            cin >> node;
            active[node] = true;

            bestOption = -inf;
            rec(1);

            cout << bestOption << '\n';
        }
        else if(t==2)
        {
            cin >> node;
            active[node] = false;

            bestOption = -inf;
            rec(1);

            cout << bestOption << '\n';
        }
        else if(t==3)
        {
            for(int i = 1;i<=n;i++)
            {
                active[i] = true;
            }
        }
        else
        {
            for(int i = 1;i<=n/5;i++)
            {
                active[i] = false;
            }
        }
    }
}
