#include <algorithm>
#include <vector>
#include <cstdio>
#include <cstring>

#define fin stdin
#define fout stdout
//FILE *fin = fopen("a.in", "r"), *fout = fopen("a.out", "w");

#define MAXN 1009

#define INF 1000000000

std::vector < int > g[MAXN];
int c[MAXN][MAXN], f[MAXN][MAXN];
int q[MAXN], from[MAXN], t;
bool viz[MAXN];

inline bool bfs() {
    memset(viz, 0, sizeof viz);
    int st = 0, dr = 0;
    q[dr++] = 0;
    viz[0] = 1;
    while (st < dr && viz[t] == 0) {
        int x = q[st++];
        for (auto &y : g[x]) {
            if (viz[y] == 0 && c[x][y] - f[x][y] > 0) {
                viz[y] = 1;
                q[dr++] = y;
                from[y] = x;
            }
        }
    }
    return viz[t];
}

int main() {
    int n, m, sum = 0;
    fscanf(fin, "%d%d", &n, &m);
    t = n + 1;

    for (int i = 1; i <= n; i++) {
        int x;
        fscanf(fin, "%d", &x);

        g[0].push_back(i);
        g[i].push_back(0);

        c[0][i] = c[i][0] = x;
        sum += x;
    }

    for (int i = 1; i <= n; i++) {
        int x;
        fscanf(fin, "%d", &x);

        g[i].push_back(t);
        g[t].push_back(i);

        c[t][i] = c[i][t] = x;
        sum += x;
    }

    for (int i = 1; i <= m; i++) {
        int x, y, z;
        fscanf(fin, "%d%d%d", &x, &y, &z);

        g[x].push_back(y);
        g[y].push_back(x);

        c[x][y] = c[y][x] = z;
    }

    int ans = 0;
    while (bfs()) {
        for (auto &x : g[t]) {
            if (viz[x]) {
                from[t] = x;
                int a = t, val = INF;
                while (a) {
                    val = std::min(val, c[from[a]][a] - f[from[a]][a]);
                    a = from[a];
                }
                a = t;
                while (a) {
                    f[from[a]][a] += val;
                    f[a][from[a]] -= val;
                    a = from[a];
                }
                ans += val;
            }
        }
    }

    fprintf(fout, "%d\n", sum - ans);

    fclose(fin);
    fclose(fout);
    return 0;
}
