#include <algorithm>
#include <vector>
#include <cstdio>
#include <cstring>

#define fin stdin
#define fout stdout
//FILE *fin = fopen("a.in", "r"), *fout = fopen("a.out", "w");

#define MAXN 1009

#define INF 1000000000

std::vector < int > g[MAXN];
int c[MAXN][MAXN], f[MAXN][MAXN];
int q[MAXN], from[MAXN], t;
bool viz[MAXN], exista[MAXN];

inline bool bfs() {
    memset(viz, 0, t + 2);
    int st = 0, dr = 0;
    q[dr++] = 0;
    viz[0] = 1;
    while (st < dr && viz[t] == 0) {
        int x = q[st++];
        for (auto &y : g[x]) {
            if (exista[y] && viz[y] == 0 && c[x][y] - f[x][y] > 0) {
                viz[y] = 1;
                q[dr++] = y;
                from[y] = x;
            }
        }
    }
    return viz[t];
}

inline void solve() {
    int sum = 0;
    for (int i = 1; i < t; i++)
        if (exista[i])
            sum += c[i][0] + c[i][t];
    int ans = 0;
    while (bfs()) {
        for (auto &x : g[t]) {
            if (viz[x]) {
                from[t] = x;
                int a = t, val = INF;
                while (a) {
                    val = std::min(val, c[from[a]][a] - f[from[a]][a]);
                    a = from[a];
                }
                a = t;
                while (a) {
                    f[from[a]][a] += val;
                    f[a][from[a]] -= val;
                    a = from[a];
                }
                ans += val;
            }
        }
    }

    for (int i = 0; i <= t; i++)
        for (auto &x : g[i])
            f[i][x] = 0;

    fprintf(fout, "%d\n", sum - ans);
}

int main() {
    int n, m;
    fscanf(fin, "%d%d", &n, &m);
    t = n + 1;

    for (int i = 1; i <= n; i++) {
        int x;
        fscanf(fin, "%d", &x);

        g[0].push_back(i);
        g[i].push_back(0);

        c[0][i] = c[i][0] = x;
    }

    for (int i = 1; i <= n; i++) {
        int x;
        fscanf(fin, "%d", &x);

        g[i].push_back(t);
        g[t].push_back(i);

        c[t][i] = c[i][t] = x;
    }

    for (int i = 1; i <= m; i++) {
        int x, y, z;
        fscanf(fin, "%d%d%d", &x, &y, &z);

        g[x].push_back(y);
        g[y].push_back(x);

        c[x][y] = c[y][x] = z;
    }

    for (int i = 0; i <= t; i++)
        exista[i] = 1;

    solve();

    int Q;
    fscanf(fin, "%d", &Q);
    for (; Q; Q--) {
        int t;
        fscanf(fin, "%d", &t);

        if (t <= 2) {
            int x;
            fscanf(fin, "%d", &x);

            if (t == 1)
                exista[x] = 1;
            else
                exista[x] = 0;

            solve();
        } else if (t == 4) {
            for (int i = 1; i <= n / 5; i++)
                exista[i] = 0;
        } else
            for (int i = 1; i <= n; i++)
                exista[i] = 1;
    }

    fclose(fin);
    fclose(fout);
    return 0;
}
