#include <bits/stdc++.h>
#define MAXN 2005
#define INF 1000000000

int n, m;
int total;
int a[1 + MAXN], b[1 + MAXN];

int active[1 + MAXN];
int S, D;
std::vector <int> G[1 + MAXN];
int C[1 + MAXN][1 + MAXN];
int E[1 + MAXN][1 + MAXN];
int F[1 + MAXN][1 + MAXN];

int father[1 + MAXN];
std::queue <int> q;
inline int BFS(){
    while(!q.empty()) q.pop();
    for(int i = 1; i <= total; i++) father[i] = 0;
    q.push(S), father[S] = D;
    while(!q.empty()){
        int node = q.front();
        q.pop();
        for(auto y: G[node])
            if(active[y] && !father[y] && C[node][y])
                father[y] = node, q.push(y);
        if(C[node][D]) return 1;
    }
    return 0;
}

int viz[1 + MAXN];
void dfs(int node){
    viz[node] = 1;
    for(auto y: G[node])
        if(active[y] && C[node][y] && !viz[y])
            dfs(y);
}

void flux(){
    while(BFS()){
        for(auto y: G[D]) if(father[y] && C[y][D]){
            father[D] = y;
            int flow = INF;
            for(int node = D; node != S; node = father[node]) flow = std::min(flow, C[father[node]][node]);
            for(int node = D; node != S; node = father[node]){
                C[father[node]][node] -= flow;
                C[node][father[node]] += flow;
            }
        }
    }
}
inline int COST(){
    int cost = 0;
    memset(viz, 0, sizeof(viz));
    dfs(S);
    for(int i = 1; i <= n; i++)
        if(active[i]){
            if(viz[i]) cost += a[i];//, printf("%d 1\n", i);
            else cost += b[i];//, printf("%d 2\n", i);
        }
    //printf("\n");
    for(int i = 1; i <= 2 * n; i++)
        for(int j = 1; j <= 2 * n; j++)
            if(active[i] && active[j] && viz[i] && !viz[j]) cost -= F[i][j];
    return cost;
}

int main(){
    FILE*fi,*fo;
    //fi = fopen("a.in","r");
    //fo = fopen("a.out","w");
    fi = stdin;
    fo = stdout;

    fscanf(fi,"%d%d", &n, &m);
    S = 2 * n + 1, D = 2 * n + 2, total = 2 * n + 2;
    for(int i = 1; i <= total; i++) active[i] = 1;
    for(int i = 1; i <= n; i++) fscanf(fi,"%d", &a[i]);
    for(int i = 1; i <= n; i++) fscanf(fi,"%d", &b[i]);
    for(int i = 1; i <= n; i++){
        G[S].push_back(i), G[i].push_back(S);
        C[S][i] = a[i];
        E[S][i] = a[i];

        G[D].push_back(n + i), G[n + i].push_back(D);
        C[n + i][D] = b[i];
        E[n + i][D] = b[i];

        G[i].push_back(n + i), G[n + i].push_back(i);
        C[i][n + i] = INF;
        E[i][n + i] = INF;
    }
    for(int i = 1; i <= m; i++){
        int x, y, t;
        fscanf(fi,"%d%d%d", &x, &y, &t);

        G[x].push_back(n + y), G[n + y].push_back(x);
        C[x][n + y] = t;
        E[x][n + y] = t;

        G[y].push_back(n + x), G[n + x].push_back(y);
        C[y][n + x] = t;
        E[y][n + x] = t;

        F[x][n + y] = F[y][n + x] = t;
    }
    flux();
    fprintf(fo,"%d\n", COST());

    int q;
    fscanf(fi,"%d", &q);
    for(int z = 1; z <= q; z++){
        int tip;
        fscanf(fi,"%d", &tip);
        if(tip == 1){
            int x;
            fscanf(fi,"%d", &x);
            active[x] = active[n + x] = 1;
            flux();
            fprintf(fo,"%d\n", COST());
        }
        else if(tip == 2){
            int x;
            fscanf(fi,"%d", &x);
            active[x] = active[n + x] = 0;
            for(int i = 1; i <= total; i++)
                for(int j = 1; j <= total; j++)
                    C[i][j] = E[i][j];
            flux();
            fprintf(fo,"%d\n", COST());
        }
        else if(tip == 3){
            for(int i = 1; i <= total; i++)
                active[i] = 1;
        }
        else{
            for(int i = 1; i <= n / 5; i++)
                active[i] = active[n + i] = 0;
            for(int i = 1; i <= total; i++)
                for(int j = 1; j <= total; j++)
                    C[i][j] = E[i][j];
        }
    }

    return 0;
}
