#include <bits/stdc++.h>
using namespace std;

const int NMAX = 1005;
const int MMAX = 100005;

int fth[NMAX], cap[NMAX][NMAX], flo[NMAX][NMAX], arr1[NMAX], arr2[NMAX];
vector<int> edg[NMAX]; bool oki[NMAX];

struct List {
	int l, r, c; } lst[MMAX];

bool bfs(int s, int d) {
	static deque<int> que;  
	for (int i = 1; i <= d; ++i) {
		oki[i] = false; }
	oki[s] = true;
	for (que.assign(1, s); que.size(); que.pop_front()) {
		int x = que.front();
		for (int y : edg[x]) {
			if (!oki[y] and cap[x][y] > flo[x][y]) {
				oki[y] = true; fth[y] = x; 
				if (y != d) {
					que.push_back(y); } } } }
	return oki[d]; }

void flow(int s, int d) {
	while (bfs(s, d)) {
		for (int x : edg[d]) {
			if (oki[x] and cap[x][d] > flo[x][d]) {
				int mn = 1e9; fth[d] = x;
				for (int y = d; y != s; y = fth[y]) {
					mn = min(mn, cap[fth[y]][y] - flo[fth[y]][y]); }
				for (int y = d; y != s; y = fth[y]) {
					flo[fth[y]][y] += mn; flo[y][fth[y]] -= mn; } } } } }

void dfs(int x) {
	oki[x] = true;
	for (int y : edg[x]) {
		if (!oki[y] and cap[x][y] > flo[x][y]) { 
			dfs(y); } } }

void mark(int s, int d) {
	for (int i = 1; i <= d; ++i) {
		oki[i] = false; }
	dfs(s); }

int main(void) {
#ifdef HOME
	freopen("resistance.in", "r", stdin);
	freopen("resistance.out", "w", stdout);
#endif
	int n, m; cin >> n >> m; int s = n + 1, d = n + 2;
	for (int i = 1; i <= n; ++i) {
		cin >> arr1[i]; cap[s][i] = arr1[i]; 
		edg[s].push_back(i); edg[i].push_back(s); }
	for (int i = 1; i <= n; ++i) {
		cin >> arr2[i]; cap[i][d] = arr2[i]; 
		edg[i].push_back(d); edg[d].push_back(i); }
	for (int i = 1; i <= m; ++i) {
		int l, r, c; cin >> l >> r >> c;
		lst[i].l = l; lst[i].r = r; lst[i].c = c;
		edg[l].push_back(r); cap[l][r] = c;
		edg[r].push_back(l); cap[r][l] = c; }	
	flow(s, d); mark(s, d);
	int ans = 0;
	for (int i = 1; i <= n; ++i) {
		ans += oki[i] ? arr1[i] : arr2[i]; }
	for (int i = 1; i <= m; ++i) {
		int l = lst[i].l, r = lst[i].r, c = lst[i].c;
		ans -= (oki[l] ^ oki[r]) ? c : 0; }
	cout << ans;
	return 0; }
