#include <bits/stdc++.h>
using namespace std;

const int NMAX = 1005;
const int MMAX = 100005;

int fth[NMAX], cap[NMAX][NMAX], flo[NMAX][NMAX], arr1[NMAX];
int arr2[NMAX], axc[NMAX][NMAX], axf[NMAX][NMAX], axc2[NMAX][NMAX], axf2[NMAX][NMAX];

pair<int ,int> qry[MMAX];
vector<int> edg[NMAX]; bool oki[NMAX], igm[NMAX];

struct List {
	int l, r, c; } lst[MMAX];

bool bfs(int s, int d) {
	static deque<int> que;  
	for (int i = 1; i <= d; ++i) {
		oki[i] = false; }
	oki[s] = true;
	for (que.assign(1, s); que.size(); que.pop_front()) {
		int x = que.front();
		for (int y : edg[x]) {
			if (igm[y] and !oki[y] and cap[x][y] > flo[x][y]) {
				oki[y] = true; fth[y] = x; 
				if (y != d) {
					que.push_back(y); } } } }
	return oki[d]; }

void flow(int s, int d, bool ok) {
	if (ok) {
		for (int x = 1; x <= d; ++x) {
			for (int y : edg[x]) {
				flo[x][y] = 0; } } }
	while (bfs(s, d)) {
		for (int x : edg[d]) {
			if (igm[x] and oki[x] and cap[x][d] > flo[x][d]) {
				int mn = 1e9; fth[d] = x;
				for (int y = d; y != s; y = fth[y]) {
					mn = min(mn, cap[fth[y]][y] - flo[fth[y]][y]); }
				for (int y = d; y != s; y = fth[y]) {
					flo[fth[y]][y] += mn; flo[y][fth[y]] -= mn; } } } } }

void dfs(int x) {
	oki[x] = true;
	for (int y : edg[x]) {
		if (igm[y] and !oki[y] and cap[x][y] > flo[x][y]) { 
			dfs(y); } } }

void mark(int s, int d) {
	for (int i = 1; i <= d; ++i) {
		oki[i] = false; }
	dfs(s); }

int cost(int n, int m) {
	int ans = 0, s = n + 1, d = n + 2; mark(s, d);
	for (int i = 1; i <= n; ++i) {
		if (!igm[i]) { continue; }
		ans += oki[i] ? arr1[i] : arr2[i]; }
	for (int i = 1; i <= m; ++i) {
		int l = lst[i].l, r = lst[i].r, c = lst[i].c;
		if (!igm[l] or !igm[r]) { continue; }
		ans -= (oki[l] ^ oki[r]) ? c : 0; }	
	return ans; }

int main(void) {
#ifdef HOME
	freopen("resistance.in", "r", stdin);
	freopen("resistance.out", "w", stdout);
#endif
	int n, m; cin >> n >> m; int s = n + 1, d = n + 2;
	for (int i = 1; i <= n; ++i) {
		cin >> arr1[i]; cap[s][i] = arr1[i]; 
		edg[s].push_back(i); edg[i].push_back(s); }
	for (int i = 1; i <= n; ++i) {
		cin >> arr2[i]; cap[i][d] = arr2[i]; 
		edg[i].push_back(d); edg[d].push_back(i); }
	for (int i = 1; i <= m; ++i) {
		int l, r, c; cin >> l >> r >> c;
		lst[i].l = l; lst[i].r = r; lst[i].c = c;
		edg[l].push_back(r); cap[l][r] = c;
		edg[r].push_back(l); cap[r][l] = c; }	
	for (int i = 1; i <= n + 2; ++i) {
		igm[i] = true; }
	flow(s, d, true); cout << cost(n, m) << "\n";
	for (int x = 1; x <= n + 2; ++x) {
		for (int y : edg[x]) { 
			axc[x][y] = cap[x][y]; axf[x][y] = flo[x][y]; } }
/*
	for (int i = 1; i <= n / 5; ++i) {
		igm[i] = false; }
	flow(s, d, true);
	for (int x = 1; x <= n + 2; ++x) {
		for (int y : edg[x]) { 
			axc2[x][y] = cap[x][y]; axf2[x][y] = flo[x][y]; } }
	*/
	int q; cin >> q;
	for (int i = 1; i <= q; ++i) {
		cin >> qry[i].first;
		if (qry[i].first <= 2) {
			cin >> qry[i].second; } }
/*
	for (int l = 1, r = 1; l <= q; l = r) {
		while (l <= q and qry[l].first == 3) {
			++l; ++r; continue; }
		if (l > q) {
			break; }
		while (r <= q; and qry[r].first != 3) {
			++r; }
		for (int x = 1; x <= n + 2; ++x) {
			for (int y : edg[x]) { 
				cap[x][y] = axc[x][y]; flo[x][y] = axf[x][y]; }
		for (int i = 1; i <= n + 2; ++i) {
			igm[i] = true; }
*/
	for (int i = 1; i <= n + 2; ++i) {
		igm[i] = true; }
	for (int i = 1; i <= q; ++i) {
		int t = qry[i].first, x = qry[i].second;
		if (t == 1) {
			igm[x] = true; 
			flow(s, d, true); cout << cost(n, m) << "\n"; }
		if (t == 2) {
			igm[x] = false;
			flow(s, d, true); cout << cost(n, m) << "\n"; }
		if (t == 3) {
			for (int x = 1; x <= n + 2; ++x) {
				for (int y : edg[x]) { 
					cap[x][y] = axc[x][y]; flo[x][y] = axf[x][y]; } } }
		if (t == 4) {
			for (int i = 1; i <= n / 5; ++i) {
				igm[i] = false; } } }
		return 0; }
