#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

using i64 = long long;
using pii = pair<int, int>;

const i64 INF = 1e12, SUM = 1e9;
const int N = 2050;

vector<pii> tg[N];

vector<int> g[N];
i64 cap[N][N], flw[N][N];
int good[N], bad[N], far[N], f[N];
bool active[12];

int n, m, q, fp;
i64 cutval;

static bool pump(int src, int snk) {
	static deque<int> dq;
	int u;

	dq.push_back(src);
	f[src] = ++fp;

	while (!dq.empty()) {
		u = dq.front();
		dq.pop_front();

		for (auto v: g[u]) if (f[v] != fp && cap[u][v] - flw[u][v] > 0) {
			f[v] = fp;
			far[v] = u;
			dq.push_back(v); } }

	return f[snk] == fp; }

static i64 flow(int src, int snk) {
	i64 rflow, augment;
	int nod;

	rflow = 0;
	while (pump(src, snk)) {
		for (auto v: g[snk]) if (f[v] == fp) {
			augment = cap[v][snk] - flw[v][snk];
			nod = v;
			while (nod != src) {
				augment = min(augment, cap[far[nod]][nod] - flw[far[nod]][nod]);
				nod = far[nod]; }

			flw[v][snk]+= augment;
			flw[snk][v]-= augment;
			nod = v;
			while (nod != src) {
				flw[far[nod]][nod]+= augment;
				flw[nod][far[nod]]-= augment;
				nod = far[nod]; }

			rflow+= augment; } }

	return rflow; }

static void add_edge(int u, int v, i64 kap) {
	g[u].push_back(v);
	g[v].push_back(u);
	cap[v][u]+= kap;
	cap[u][v]+= kap; }

static void build_graph() {
	function<int(int)> st = [&](int nod) { return nod; };
	function<int(int)> dr = [&](int nod) { return nod + n + 1; };
	int src = 0, snk = 2 * n + 5;

	for (int u = 1; u <= n; ++u) {
		add_edge(0, st(u), INF);
		add_edge(st(u), dr(u), SUM - good[u]);
		add_edge(dr(u), snk, SUM - bad[u]); }

	for (int u = 1; u <= n; ++u) {
		for (auto v: tg[u]) if (v.x < u)
			add_edge(dr(u), dr(v.x), v.y); } }

int main() {
#ifdef HOME
	freopen("resistance.in", "r", stdin);
	freopen("resistance.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	memset(active, true, sizeof active);

	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> good[i];
	for (int i = 1; i <= n; ++i)
		cin >> bad[i];
	for (int u, v, c, i = 0; i < m; ++i) {
		cin >> u >> v >> c;
		tg[u].emplace_back(v, c);
		tg[v].emplace_back(u, c); }

	build_graph();
	cutval = flow(0, 2 * n + 5);

	cout << SUM * n - cutval << '\n';

	cin >> q;
	while (q--) {
		int op, nod, tmp;
		cin >> op;
		switch (op) {
		case 1: { // baga
			cin >> nod;
			active[nod] = true;
			break; }
		case 2: { // scoate
			cin >> nod;
			active[nod] = false;
			break; }
		case 3: { // reset
			for (int i = 1; i <= n; ++i)
				active[nod] = true;
			break; }
		case 4: { // pleaca
			for (int i = 1; i <= n / 5; ++i)
				active[nod] = false;
			break; } }


		cutval = 0;
		for (int u, msk = 0; msk < (1 << n); ++msk) {
			i64 tmp = 0;
			for (int bit = 0; bit < n; ++bit) if (active[bit]) {
				u = bit + 1;
				tmp+= (((1 << bit) & msk) ? good : bad)[u];
				for (auto v: tg[u]) if (active[v.x]) {
					bool he = msk & (1 << v.x - 1);
					bool me = msk & (1 << bit);
					if (he != me)
						tmp-= v.y; } }
			cutval = max(cutval, tmp); }

		cout << cutval << '\n'; }

	return 0; }

