#include <bits/stdc++.h>

using namespace std;

const int Nmax = 1005;

int S, D, n, m, Q, ans;
int good[Nmax], bad[Nmax], act[Nmax];

class Graph
{
    int c[Nmax][Nmax], f[Nmax][Nmax], t[Nmax], dist[Nmax];
    vector<int> v[Nmax];
    bool active[Nmax];

    bool bfs()
    {
        memset(t, -1, sizeof(t));
        memset(dist, -1, sizeof(dist));
        queue<int> q;
        q.push(S);
        t[S] = 0; dist[S] = 0;

        int node;
        while(q.size())
        {
            node = q.front();
            q.pop();

            for(auto it : v[node])
                if(active[it] && t[it] == -1 && f[node][it] < c[node][it])
                {
                    t[it] = node;
                    dist[it] = dist[node] + 1;
                    q.push(it);
                    if(it == D) return 1;
                }
        }
        return 0;
    }

    int dfs(int node, int flow)
    {
        if(!flow) return 0;
        if(node == D) return flow;

        int ans = 0;
        for(auto it : v[node])
            if(dist[it] == dist[node] + 1)
            {
                int add = dfs(it, min(flow, c[node][it] - f[node][it]));
                flow -= add;
                ans += add;

                f[node][it] += add;
                f[it][node] -= add;
            }

        if(!ans) dist[node] = -1;
        return ans;
    }

    public:

        void reset()
        {
            memset(f, 0, sizeof(f));
        }

        void add_edge(int x, int y, int cost)
        {
            v[x].push_back(y);
            v[y].push_back(x);
            c[x][y] = c[y][x] = cost;
        }

        void set_node(int node, bool v)
        {
            if(active[node] == v) return;
            active[node] = v;

            ans += max(good[node], bad[node]) * (v == 1 ? 1 : -1);
        }

        int max_flow()
        {
            active[S] = active[D] = 1;
            int flow = 0;

            while(bfs())
                flow += dfs(S, 1e9);
            return flow;
        }
} graph;

void subtask1()
{
    int tip, x, i;
    while(Q--)
    {
        cin >> tip;
        if(tip == 1)
        {
            cin >> x;
            graph.set_node(x, 1);
        }
        else if(tip == 2)
        {
            cin >> x;
            graph.set_node(x, 0);
        }
        else if(tip == 3)
            for(i=1; i<=n; ++i) graph.set_node(i, 1);
        else for(i=1; i<=n/5; ++i) graph.set_node(i, 0);

        if(tip <= 2)
        {
            graph.reset();
            cout << ans - graph.max_flow() << '\n';
        }
    }

}

int main()
{
  //  freopen("input", "r", stdin);
    cin.sync_with_stdio(false);

    int i, x, y, cost;

    cin >> n >> m;
    for(i=1; i<=n; ++i) cin >> good[i];
    for(i=1; i<=n; ++i) cin >> bad[i];

    S = 0; D = n + 1;

    for(i=1; i<=n; ++i)
        if(good[i] > bad[i])
        {
            graph.add_edge(S, i, good[i] - bad[i]);
        //    ans += good[i];
        }
        else
        {
            graph.add_edge(i, D, bad[i] - good[i]);
          //  ans += bad[i];
        }

    for(i=1; i<=m; ++i)
    {
        cin >> x >> y >> cost;
        graph.add_edge(x, y, cost);
    }

    for(i=1; i<=n; ++i) graph.set_node(i, 1);

    cout << ans - graph.max_flow() << '\n';

    cin >> Q;
    if(n <= 10 && m <= 45 && Q <= 100) subtask1();
       // else subtask2();

    return 0;
}
