#include <bits/stdc++.h>

using namespace std;

const int Nmax = 1005;

int S, D, n, m, ans;
int good[Nmax], bad[Nmax];

class Graph
{
    int c[Nmax][Nmax], f[Nmax][Nmax], t[Nmax];
    vector<int> v[Nmax];

    bool bfs()
    {
        memset(t, -1, sizeof(t));
        queue<int> q;
        q.push(S);
        t[S] = 0;

        int node;
        while(q.size())
        {
            node = q.front();
            q.pop();

            for(auto it : v[node])
                if(t[it] == -1 && f[node][it] < c[node][it])
                {
                    t[it] = node;
                    q.push(it);
                    if(it == D) return 1;
                }
        }
        return 0;
    }

    public:
        void add_edge(int x, int y, int cost)
        {
            v[x].push_back(y);
            v[y].push_back(x);
            c[x][y] = c[y][x] = cost;
        }

        int max_flow()
        {
            int node, flow = 0, dad, add = 0;
            while(bfs())
            {
                node = D;
                add = 1e9;

                while(node != S)
                {
                    dad = t[node];
                    add = min(add, c[dad][node] - f[dad][node]);
                    node = dad;
                }

                flow += add;

                node = D;
                while(node != S)
                {
                    dad = t[node];
                    f[dad][node] += add;
                    f[node][dad] -= add;
                    node = dad;
                }
            }

            return flow;
        }
} graph;

int main()
{
  //  freopen("input", "r", stdin);
    cin.sync_with_stdio(false);

    int i, x, y, cost;

    cin >> n >> m;
    for(i=1; i<=n; ++i) cin >> good[i];
    for(i=1; i<=n; ++i) cin >> bad[i];

    S = 0; D = n + 1;

    for(i=1; i<=n; ++i)
        if(good[i] > bad[i])
        {
            graph.add_edge(S, i, good[i] - bad[i]);
            ans += good[i];
        }
        else
        {
            graph.add_edge(i, D, bad[i] - good[i]);
            ans += bad[i];
        }

    for(i=1; i<=m; ++i)
    {
        cin >> x >> y >> cost;
        graph.add_edge(x, y, cost);
    }

    cout << ans - graph.max_flow() << '\n';
    return 0;
}
