#include <bits/stdc++.h>
using namespace std;

const int NMAX = 1010;
int flow[NMAX + 10][NMAX + 10];
int tata[NMAX + 10];
vector <int> adia[NMAX + 10];
int s, d;

bool calc_tata()
{
    queue <int> q;
    q.push(s);
    memset(tata, 0, sizeof tata);
    tata[s] = -1;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        if (x == d)
            continue;
        for (auto i : adia[x]) {
            if (flow[x][i] && !tata[i]) {
                tata[i] = x;
                q.push(i);
            }
        }
    }
    return tata[d] != 0;
}

int augment()
{
    int nr = 1e9;
    for (int i = d; tata[i] != -1; i = tata[i])
        nr = min(nr, flow[tata[i]][i]);
    for (int i = d; tata[i] != -1; i = tata[i])
        flow[tata[i]][i] -= nr, flow[i][tata[i]] += nr;
    return nr;
}

int get_flow()
{
    int ans = 0;
    while (calc_tata()) {
        for (auto i : adia[d]) {
            if (flow[i][d] && tata[i]) {
                tata[d] = i;
                ans += augment();
            }
        }
    }
    return ans;
}

int main()
{
    int n, m, cost = 0;
    cin >> n >> m;
    s = 1, d = n + 2;
    for (int i = 2; i <= n + 1; i++) {
        int x;
        cin >> x;
        adia[s].push_back(i);
        adia[i].push_back(s);
        adia[d].push_back(i);
        adia[i].push_back(d);
        flow[s][i] = x;
        cost += x;
    }
    for (int i = 2; i <= n + 1; i++) {
        int x;
        cin >> x;
        flow[i][d] = x;
        cost += x;
    }

    while (m--) {
        int a, b, c;
        cin >> a >> b >> c;
        adia[a + 1].push_back(b + 1);
        adia[b + 1].push_back(a + 1);
        flow[a + 1][b + 1] = flow[b + 1][a + 1] = c;
    }

    int ans = get_flow();

    cout << cost - ans << '\n';
    return 0;
}




















