#include <vector>
#include <queue>
#include <cstring>
#include <iostream>

using namespace std;

const int NMAX = 1010;
int flow[NMAX + 10][NMAX + 10];
int used[NMAX + 10][NMAX + 10];
bool activ[NMAX + 10];
int tata[NMAX + 10];
bool viz[NMAX + 10];
vector <int> adia[NMAX + 10];
int s, d;

bool push(int nod, int c, int w = s)
{
	if (nod == w || nod == d)
		return 1;
	viz[nod] = 1;
	for (auto i : adia[nod]) {
		if (activ[i] && !viz[i] && flow[nod][i] >= c && push(i, c, w)) {
			flow[nod][i] -= c, flow[i][nod] += c, used[nod][i] += c, used[i][nod] -= c;
			return true;
		}
	}
	return false;
}
bool pull(int nod, int c)
{
	if (nod == s || nod == d)
		return 1;
	viz[nod] = 1;
	for (auto i : adia[nod]) {
		if (activ[i] && !viz[i] && used[nod][i] >= c && pull(i, c)) {
			flow[nod][i] += c, flow[i][nod] -= c, used[nod][i] -= c, used[i][nod] += c;
			return true;
		}
	}
	return false;
}

bool calc_tata()
{
	queue <int> q;
	q.push(s);
	memset(tata, 0, sizeof tata);
	tata[s] = -1;
	while (!q.empty()) {
		int x = q.front();
		q.pop();
		if (x == d)
			continue;
		for (auto i : adia[x]) {
			if (flow[x][i] && !tata[i] && activ[i]) {
				tata[i] = x;
				q.push(i);
			}
		}
	}
	return tata[d] != 0;
}

int augment()
{
	int nr = 1e9;
	for (int i = d; tata[i] != -1; i = tata[i])
		nr = min(nr, flow[tata[i]][i]);
	for (int i = d; tata[i] != -1; i = tata[i])
		flow[tata[i]][i] -= nr, flow[i][tata[i]] += nr, used[tata[i]][i] += nr, used[i][tata[i]] -= nr;
	return nr;
}

int get_flow()
{
	int ans = 0;
	while (calc_tata()) {
		for (auto i : adia[d]) {
			if (flow[i][d] && tata[i] && activ[i]) {
				tata[d] = i;
				ans += augment();
			}
		}
	}
	return ans;
}

void make_flow()
{
	int c = 1000;
	while (c) {
		memset(viz, 0, sizeof viz);
		if (!push(s, c, d))
			c /= 2;
	}
}

void make_pull(int nod, int c)
{
	int ans = 0, act = c;
	while (ans != c) {
		memset(viz, 0, sizeof viz);
		if (pull(nod, act))
			ans += act;
		else
			act /= 2;
	}
	if (ans != c)
		cout << "WTF";
}void make_push(int nod, int c)
{
	int ans = 0, act = c;
	while (ans != c) {
		memset(viz, 0, sizeof viz);
		if (push(nod, act))
			ans += act;
		else
			act /= 2;
	}
	if (ans != c)
		cout << "WTF";
}
int n;

void disable(int nod)
{
	activ[nod] = 0;
	for (int i = 1; i <= n + 2; i++) {
		for (auto j : adia[i]) {
			flow[i][j] += used[i][j];
			used[i][j] = 0;
		}
	}
	return;
	for (auto i : adia[nod]) {
		if (used[nod][i] > 0) {
			make_pull(i, used[nod][i]);
			flow[nod][i] += used[nod][i], flow[i][nod] = flow[nod][i];
			used[nod][i] = used[i][nod] = 0;
		}
		else if (used[nod][i] < 0) {
			make_push(i, -used[nod][i]);
			flow[nod][i] += used[nod][i], flow[i][nod] = flow[nod][i];
			used[nod][i] = used[i][nod] = 0;
		}
	}
}
void enable(int nod)
{
	activ[nod] = 1;
}

int sum_flow()
{
	int sum = 0;
	for (auto i : adia[s])
		sum += used[s][i];
	return sum;
}

int cst[NMAX + 10], cdr[NMAX + 10];

int main()
{
	int m, cost = 0;
	cin >> n >> m;
	s = 1, d = n + 2;
	activ[s] = activ[d] = 1;
	for (int i = 2; i <= n + 1; i++) {
		activ[i] = 1;
		int x;
		cin >> x;
		cst[i] = x;
		adia[s].push_back(i);
		adia[i].push_back(s);
		adia[d].push_back(i);
		adia[i].push_back(d);
		flow[s][i] = x;
		cost += x;
	}
	for (int i = 2; i <= n + 1; i++) {
		int x;
		cin >> x;
		cdr[i] = x;
		flow[i][d] = x;
		cost += x;
	}

	while (m--) {
		int a, b, c;
		cin >> a >> b >> c;
		adia[a + 1].push_back(b + 1);
		adia[b + 1].push_back(a + 1);
		flow[a + 1][b + 1] = flow[b + 1][a + 1] = c;
	}

	int ans = get_flow();

	cout << cost - ans << '\n';

	int q;
	cin >> q;

	while (q--) {
		int t;
		cin >> t;
		if (t == 3) {
			for (int i = 2; i <= n + 1; i++) {
				if (!activ[i])
					enable(i), cost += cst[i] + cdr[i];
			}
		}
		else if (t == 4) {
			for (int i = 1; i <= n / 5; i++) {
				if (activ[i + 1])
					disable(i + 1), cost -= cst[i + 1] + cdr[i + 1];
			}
		}
		else if (t == 1) {
			int x;
			cin >> x;
			enable(x + 1);
			cost += cst[x + 1] + cdr[x + 1];
		}
		else {
			int x;
			cin >> x;
			disable(x + 1);
			cost -= cst[x + 1] + cdr[x + 1];
		}
		if (t == 1 || t == 2) {
			get_flow();
			cout << cost - sum_flow() << '\n';
		}
	}

	return 0;
}




