#include <iostream>
#include <cstdio>
#include <vector>
#include <deque>
#include <stdlib.h>
#include <algorithm>

using namespace std;

int n, m;
const int MAX_N = 1e3 + 5;
short cap[MAX_N][MAX_N];
short flow[MAX_N][MAX_N];

vector<int> edges[MAX_N];
int p[MAX_N];

int max_flow = 0;

void pump_flow() {
    while ( 1 ) {
        deque<int> d;
        for ( int i = 1; i <= n + 1; i++ )
            p[i] = -1;
        d.push_back( 0 );
        while ( d.size() && p[n + 1] == -1 ) {
            int x = d.front();
            d.pop_front();
            for ( int y : edges[x] )
                if ( p[y] == -1 && 0 < cap[x][y] ) {
                    p[y] = x;
                    d.push_back(y);
                }
        }
        if ( p[n + 1] == -1 )
            break;

        int m = 1e9;
        for ( int i = n + 1; i != 0; i = p[i] )
            m = min( m, (int)cap[p[i]][i] );
        for ( int i = n + 1; i != 0; i = p[i] ) {
            cap[p[i]][i] -= m;
            cap[i][p[i]] += m;
        }
        max_flow += m;

    }
}

int main() {
    freopen( "input.txt", "r", stdin );

    int s = 0;
    cin >> n >> m;

    for ( int i = 1; i <= n; i++ ) {
        int x;
        cin >> x;
        s += x;
        edges[0].push_back( i );
//        edges[i].push_back( 0 );
        cap[0][i] = x;
    }
    for ( int i = 1; i <= n; i++ ) {
        int x;
        cin >> x;
        s += x;
        edges[n + 1].push_back( i );
        edges[i].push_back( n + 1 );
        cap[i][n + 1] = x;
    }

    for ( int i = 0; i < m; i++ ) {
        int x, y, t;
        cin >> x >> y >> t;
        edges[x].push_back( y );
        edges[y].push_back( x );
        cap[x][y] = cap[y][x] = t;
    }
    srand(11);
    for ( int i = 0; i <= n + 1; i++ )
        random_shuffle(edges[i].begin(), edges[i].end());

    pump_flow();
    cout << s - max_flow << endl;

    return 0;
}
