#include <bits/stdc++.h>

using namespace std;
using nagai = long long;
using uint = unsigned int;
mt19937 rnd(228);

uint seed = 123123123;
uint xrand()
{
	seed ^= seed << 2;
	seed ^= seed >> 7;
	seed ^= seed << 7;
	return seed;
}
int mod;

int mult(int a, int b)
{
	return (nagai)a * b % mod;
}

int add(int a, int b)
{
	a += b;
	if (a >= mod)
		return a - mod;
	return a;
}

struct ed
{
	int to, f, c, inv;
};

const int N = 1010;
vector<ed> g[N];

void add_edge(int a, int b, int c)
{
	ed eda = {b, 0, c, (int)g[b].size()};
	ed edb = {a, 0, c, (int)g[a].size()};
	g[a].push_back(eda);
	g[b].push_back(edb);
}
vector<tuple<int, int, int>> eds;
bool cur[N];

int n, m;
int sz;
vector<int> as, bs;

int d[N];

bool used[N];
int ptr[N];

int dfs(int u, int t, int cur)
{
	if (cur == 0 || used[u])
		return 0;
	if (u == t)
		return cur;
	used[u] = true;
	for (; ptr[u] < g[u].size(); ++ptr[u])
	{
		auto& e = g[u][ptr[u]];
		if (d[e.to] != d[u] + 1)
			continue;
		int f = min(cur, e.c - e.f);
		if (f = dfs(e.to, t, f))
		{
			e.f += f;
			g[e.to][e.inv].f -= f;
			return f;
		}
	}
	return 0;
}

vector<int> q;
bool bfs(int s, int t)
{
	q = {s};
	fill(d, d + sz, -1);
	d[s] = 0;
	for (int i = 0; i < q.size(); ++i)
	{
		int x = q[i];
		for (auto& e : g[x])
			if (d[e.to] == -1 && e.f < e.c)
				q.emplace_back(e.to), d[e.to] = d[x] + 1;
	}
	return d[t] != -1;
}

int dinic(int s, int t)
{
	int ans = 0;
	while (bfs(s, t))
	{
		fill(ptr, ptr + sz, 0);
		int f = 0;
		while (true)
		{
			fill(used, used + sz, false);
			f = dfs(s, t, 1e9);
			ans += f;
			if (!f)
				break;
		}
	}
	/*
	for (int i = 0; i < sz; ++i)
		for (auto e : g[i])
			cerr << i << ' ' << e.to << ' ' << e.f << '\n';
	 */
	return ans;
}

nagai perm_ans;

int calc()
{
	sz = n + 2;
	for (int i = 0; i < sz; ++i)
		g[i].clear();
	for (auto& x : eds)
	{
		int a, b, c;
		tie(a, b, c) = x;
		if (cur[a] && cur[b])
			add_edge(a, b, c);
	}
	int s = n, t = n + 1;
	perm_ans = 0;
	for (int i = 0; i < n; ++i)
	{
		if (cur[i])
		{
			perm_ans += as[i] + bs[i];
			add_edge(s, i, as[i]);
			add_edge(i, t, bs[i]);
		}
	}
	int f = dinic(s, t);
	return perm_ans - f;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	as.resize(n);
	bs.resize(n);
	for (auto& x : as)
		cin >> x;
	for (auto& x : bs)
		cin >> x;
	for (int i = 0; i < m; ++i)
	{
		int x, y, t;
		cin >> x >> y >> t;
		--x, --y;
		eds.emplace_back(x, y, t);
//		add_edge(x, y, t);
	}
	int q;
	cin >> q;
	fill(cur, cur + N, true);
	cout << calc() << '\n';
	while (q--)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int x;
			cin >> x;
			--x;
			cur[x] = true;
		}
		if (t == 2)
		{
			int x;
			cin >> x;
			--x;
			cur[x] = false;
		}
		if (t == 3)
		{
			fill(cur, cur + n, true);
		}
		if (t == 4)
			fill(cur, cur + n / 5, false);
		if (t == 1 || t == 2)
			cout << calc() << '\n';
	}
}
