#include <bits/stdc++.h>

using namespace std;

struct edge
{
	int v, to, cap;
};

const int N = 1e5 + 7;

vector <edge> e;
vector <int> g[N];
int dist[N];
int ptr[N];

void add_edge(int v, int to, int cap)
{
	g[v].push_back(e.size());
	e.push_back({v, to, cap});
	g[to].push_back(e.size());
	e.push_back({to, v, 0});
}

int dfs(int v, int t, int fl)
{
	if (v == t)
	{
		return fl;
	}
	for (int &j = ptr[v]; j < (int) g[v].size(); j++)
	{
		int ind = g[v][j];
		if (e[ind].cap > 0 && dist[e[ind].to] == dist[v] + 1)
		{
			int go = dfs(e[ind].to, t, min(fl, e[ind].cap));
			if (go > 0)
			{
				e[ind].cap -= go;
				e[ind ^ 1].cap += go;
				return go;
			}
		}
	}
	return 0;
}

bool push_flow(int s, int t, int verts)
{
	queue <int> q;
	q.push(s);
	for (int i = 0; i < verts; i++)
	{
		dist[i] = -1;
		ptr[i] = 0;
	}
	dist[s] = 0;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int ind : g[v])
		{
			if (e[ind].cap > 0 && dist[e[ind].to] == -1)
			{
				dist[e[ind].to] = dist[v] + 1;
				q.push(e[ind].to);
			}
		}
	}
	return (dist[t] != -1);
}

bool on[N];
int l[N], r[N];
int a[N], b[N], w[N];

int n, m;

map <vector <int>, int> press;
int ans = 0;
int s, t;


int sliva()
{
	s = n, t = n + 1;
	e.clear();
	for (int i = 0; i < n + 2; i++) g[i].clear();
	ans = 0;
	for (int i = 0; i < n; i++) if (on[i])
	{
		add_edge(s, i, l[i]);
		add_edge(i, t, r[i]);
		ans += l[i] + r[i];
	}
	for (int i = 0; i < m; i++)
	{
		if (on[a[i]] && on[b[i]])
		{
			add_edge(a[i], b[i], w[i]);
			add_edge(b[i], a[i], w[i]);
		}
	}
	while (push_flow(s, t, n + 2))
	{
		while (int ret = dfs(s, t, n + 2))
		{
			ans -= ret;
		}
	}
	return ans;
}



void upd(int v, int t)
{
	if (t == 1)
	{
		if (on[v]) return;
		on[v] = true;
		add_edge(s, v, l[v]);
		add_edge(v, t, r[v]);
		ans += l[v] + r[v];
		for (int i = 0; i < m; i++)
		{
			if (on[a[i]] && on[b[i]] && (a[i] == v || b[i] == v))
			{
				add_edge(a[i], b[i], w[i]);
				add_edge(b[i], a[i], w[i]);
			}
		}
		while (push_flow(s, t, n + 2))
		{
			while (int ret = dfs(s, t, n + 2))
			{
				ans -= ret;
			}
		}
	}
	else
	{
		if (!on[v]) return;
		on[v] = 0;
		ans = 0;
		sliva();
	}
}

/*
void solve(vector <pair <int, int> > qs)
{
	for (int i = 0; i < n; i++) on[i] = 1;
	vector <int> first(n, -1);
	for (int i = 0; i < (int) qs.size(); i++)
	{
		auto c = qs[i];
		int t = c.first;
		if (t == 2)
		{
			if (first[c.second] == -1)
			{
				first[c.second] = i;
				on[c.second] = 0;
			}
		}
		else
		{
			for (int x = 0; x < n / 5; x++)
			{
				if (first[x] == -1)
				{
					first[x] = i;
					on[x] = 0;
				}
			}
		}
	}
	sliva();
	vector <int> ret;
	for (int i = (int) qs.size() - 1; i >= 0; i--)
	{
		auto c = qs[i];
		if (c.first == 2)
		{
			ret.push_back(ans);
		}
		for (int x = 0; x < n; x++)
		{
			if (first[x] == i)
			{
				upd(x);
			}
		}
	}
	reverse(ret.begin(), ret.end());
	for (int x : ret) cout << x << '\n';
}
*/

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; i++) on[i] = 1;
	for (int i = 0; i < n; i++)
	{
		cin >> l[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> r[i];
	}
	for (int i = 0; i < m; i++)
	{
		cin >> a[i] >> b[i] >> w[i];
		a[i]--, b[i]--;
	}
	/*
	if (n <= 10)
	{
		cout << sliva() << '\n';
		for (int i = 0; i < n; i++) on[i] = 1;
		int q;
		cin >> q;
		for (int i = 0; i < q; i++)
		{
			int t;
			cin >> t;
			if (t == 1)
			{
				int v;
				cin >> v;
				v--;
				on[v] = 1;
				cout << sliva() << '\n';
			}
			else if (t == 2)
			{
				int v;
				cin >> v;
				v--;
				on[v] = 0;
				cout << sliva() << '\n';
			}
			else if (t == 3)
			{
				for (int i = 0; i < n; i++) on[i] = 1;
			}
			else if (t == 4)
			{
				for (int i = 0; i < n / 5; i++) on[i] = 0;
			}
		}
		return 0;
	}
	*/
	cout << sliva() << '\n';
	vector <pair <int, int> > e;
	int op = 0;
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int v;
			cin >> v;
			v--;
			upd(v, 1);
			cout << ans << '\n';
		}
		else if (t == 2)
		{
			int v;
			cin >> v;
			v--;
			upd(v, 2);
			cout << ans << '\n';
		}
		else if (t == 3)
		{
			for (int j = 0; j < n; j++) on[j] = 1;
			sliva();
		}
		else
		{
			for (int j = 0; j < n / 5; j++) 
			{
				upd(j, 2);
			}
		}
	}
}
