#include <bits/stdc++.h>

using namespace std;

struct edge
{
	int v, to, cap;
};

const int N = 1e5 + 7;

vector <edge> e;
vector <int> g[N];

void add_edge(int v, int to, int cap)
{
	g[v].push_back(e.size());
	e.push_back({v, to, cap});
	g[to].push_back(e.size());
	e.push_back({to, v, 0});
}

int push_flow(int s, int t, int verts)
{
	queue <int> q;
	q.push(s);
	vector <int> dist(verts, -1);
	vector <int> par(verts, -1);
	dist[s] = 1e9;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int ind : g[v])
		{
			if (e[ind].cap > 0 && dist[e[ind].to] == -1)
			{
				dist[e[ind].to] = min(dist[v], e[ind].cap);
				par[e[ind].to] = ind;
				q.push(e[ind].to);
			}
		}
	}
	if (dist[t] == -1)
	{
		return 0;
	}
	int fl = dist[t];
	int cur = t;
	while (cur != s)
	{
		e[par[cur]].cap -= fl;
		e[par[cur] ^ 1].cap += fl;
		cur = e[par[cur]].v;
	}
	return fl;
}

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	int s = n, t = n + 1;
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		ans += x;
		add_edge(s, i, x);
	}
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		ans += x;
		add_edge(i, t, x);
	}
	for (int i = 0; i < m; i++)
	{
		int a, b, w;
		cin >> a >> b >> w;
		a--, b--;
		add_edge(a, b, w);
		add_edge(b, a, w);
	}
	while (int ret = push_flow(s, t, n + 2))
	{
		ans -= ret;
	}
	/*
	for (int i = 0; i < q; i++)
	{
		int t;
		cin >> t;
		if (t == 3)
		{
		}
	}
	*/
	cout << ans << '\n';
}
