#include <bits/stdc++.h>

using namespace std;

struct edge
{
	int v, to, cap;
};

const int N = 1e5 + 7;

vector <edge> e;
vector <int> g[N];
int dist[N];
int ptr[N];

void add_edge(int v, int to, int cap)
{
	g[v].push_back(e.size());
	e.push_back({v, to, cap});
	g[to].push_back(e.size());
	e.push_back({to, v, 0});
}

int dfs(int v, int t, int fl)
{
	if (v == t)
	{
		return fl;
	}
	for (int &j = ptr[v]; j < (int) g[v].size(); j++)
	{
		int ind = g[v][j];
		if (e[ind].cap > 0 && dist[e[ind].to] == dist[v] + 1)
		{
			int go = dfs(e[ind].to, t, min(fl, e[ind].cap));
			if (go > 0)
			{
				e[ind].cap -= go;
				e[ind ^ 1].cap += go;
				return go;
			}
		}
	}
	return 0;
}

bool push_flow(int s, int t, int verts)
{
	queue <int> q;
	q.push(s);
	for (int i = 0; i < verts; i++)
	{
		dist[i] = -1;
		ptr[i] = 0;
	}
	dist[s] = 0;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int ind : g[v])
		{
			if (e[ind].cap > 0 && dist[e[ind].to] == -1)
			{
				dist[e[ind].to] = dist[v] + 1;
				q.push(e[ind].to);
			}
		}
	}
	return (dist[t] != -1);
}

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	int s = n, t = n + 1;
	int ans = 0;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		ans += x;
		add_edge(s, i, x);
	}
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		ans += x;
		add_edge(i, t, x);
	}
	for (int i = 0; i < m; i++)
	{
		int a, b, w;
		cin >> a >> b >> w;
		a--, b--;
		add_edge(a, b, w);
		add_edge(b, a, w);
	}
	while (push_flow(s, t, n + 2))
	{
		while (int ret = dfs(s, t, n + 2))
		{
			ans -= ret;
		}
	}
	cout << ans << '\n';
}
