#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2> 
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
} 

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) {
		_in >> i;
	}
	return _in;
} 

template<typename T1, typename T2> 
ostream &operator << (ostream &_out, const pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
} 

template<typename T> 
ostream &operator << (ostream &_out, const vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) {
			_out<< ' ';
		} else {
			OK = true;
		}
		_out << i;
	}
	return _out;
} 


int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(string s) {
	for (auto c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {	
	writeString(to_string(v));
}

const int N = 1e3 + 10;

int n, m, k;
vector<int> e;
vector<int> c;
vector<int> edge[N];
vector<pair<int, pair<int, int>>> my_edge;

void make_edge(int i, int j, int v) {
	edge[i].pb(e.size());
	e.pb(j);
	c.pb(v);
	edge[j].pb(e.size());
	e.pb(i);
	c.pb(v);
}

int s, t;
int flow;
int h[N];
int cur[N];

int dfs(int i, int curf = 1e9) {
	if (curf <= 0) return 0;
	if (i == t) {
		flow += curf;
		return curf;
	}
	for (; cur[i] < edge[i].size(); ++cur[i]) {
		int id = edge[i][cur[i]];
		if (h[e[id]] <= h[i]) continue;
		int val = dfs(e[id], min(c[id], curf));
		if (val) {
			c[id] -= val;
			c[id ^ 1] += val;
			return val;
		}
	}
	return 0;
}

bool bfs() {
	for (int i = s; i <= t; ++i) {
		h[i] = 1e9;
		cur[i] = 0;
	}
	h[s] = 0;
	queue<int> que;
	que.push(s);
	while (que.size()) {
		int u = que.front();
		que.pop();
		for (int id : edge[u]) {
			if (c[id] && h[e[id]] > h[u] + 1) {
				h[e[id]] = h[u] + 1;
				que.push(e[id]);
			}
		}
	}
	if (h[t] == 1e9) return false;
	while (dfs(s));
	return true;
}

int w[N][2];
bitset<N> alive;

int find_ans(int k = -1) {
	int sum = 0;
	s = 0, t = n + 1;
	if (k == -1) {
		flow = 0;
		for (int i = 0; i <= n + 1; ++i) {
			edge[i].clear();
		}
		e.clear();
		c.clear();
		for (int i = 1; i <= n; ++i) {
			if (alive[i]) {
				sum += w[i][0] + w[i][1];
				make_edge(s, i, w[i][0]);
				make_edge(i, t, w[i][1]);
			}
		}
		for (auto v : my_edge) {
			if (alive[v.y.x] && alive[v.y.y]) {
				make_edge(v.y.x, v.y.y, v.x);
			}
		}
	} else {
		for (int i = 1; i <= n; ++i) {
			if (alive[i]) sum += w[i][0] + w[i][1];
		}
		make_edge(s, k, w[k][0]);
		make_edge(k, t, w[k][1]);
		for (auto v : my_edge) {
			if ((v.y.x == k || v.y.y == k) && alive[v.y.x] && alive[v.y.y]) {
				make_edge(v.y.x, v.y.y, v.x);
			}
		}
	}
	while (bfs());
	return sum - flow;
}

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) cin >> w[i + 1][0];
	for (int i = 0; i < n; ++i) cin >> w[i + 1][1];
	for (int i = 0; i < m; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		my_edge.pb({c, {a, b}});
	}
	cin >> k;
	alive.flip();
	cout << find_ans() << endl;
	for (int i = 0; i < k; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int v;
			cin >> v;
			alive[v] = true;
			cout << find_ans(v) << endl;
		} else if (t == 2) {
			int v;
			cin >> v;
			alive[v] = false;
			cout << find_ans() << endl;
		} else if (t == 3) {
			alive.reset();
			alive.flip();
			find_ans();
		} else {
			for (int j = 0; j * 5 <= n; ++j) {
				alive[j] = false;
			}
			find_ans();
		}
	}
}