#include "bits/stdc++.h"

#define pb push_back
#define len(v) ((int)v.size())
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << p.x << " " << p.y;
	return os;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}


void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

struct Flow {
	struct Edge;
	vector<vector<Edge>> g;
	struct Edge {
		int flow = 0;
		int lim = 0;
		int to;
		int pair_id;

		Edge() {}

		Edge(int _to, int _lim, int _pair_id) {
			to = _to;
			lim = _lim;
			pair_id = _pair_id;
		}

		int max_push() {
			return lim - flow;
		}
	};

	void push(Edge &edge, int x) {
		edge.flow += x;
		g[edge.to][edge.pair_id].flow -= x;
	}

	int st, end;

	void add_edge(int a, int b, int lim) {
		g[a].emplace_back(b, lim, len(g[b]));
		g[b].emplace_back(a, 0, len(g[a]) - 1);
	}

	Flow(int n, int _st, int _end) {
		g.resize(n);
		st = _st;
		end = _end;
	}

	vector<bool> used;

	int dfs(int v, int _min) {
		if (v == end) return _min;
		// cout << v << " " << _min << endl;
		used[v] = true;
		for (Edge &e : g[v]) {
			if (!used[e.to] && e.max_push()) {
				int t = dfs(e.to, min(_min, e.max_push()));
				if (t) {
					push(e, t);
					return t;
				}
			}
		}
		return 0;
	}

	int max_flow() {
		used = vector<bool>(len(g), false);
		while (dfs(st, 1e9)) {
			used = vector<bool>(len(g), false);
		}
		int rez = 0;
		for (Edge e : g[st]) {
			rez += e.flow;
		}
		return rez;
	}
};

int n, m;

void run() {
	cin >> n >> m;
	Flow flow(n + 2, n, n + 1);	
	vector<int> F(n), S(n);
	cin >> F >> S;
	int all = 0;
	for (int i = 0; i < m; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		a--;b--;
		flow.add_edge(a, b, w);
		flow.add_edge(b, a, w);
		// all += w;
	}
	for (int x : F) {
		all += x;
	}	
	for (int x : S) {
		all += x;
	}
	// cout << all << endl;

	for (int i = 0; i < n; i++) {
		flow.add_edge(n, i, F[i]);
		flow.add_edge(i, n + 1, S[i]);
	}
	// cout << flow.max_flow() << endl;
	cout << all - flow.max_flow() << endl;
}