#include <bits/stdc++.h>

using namespace std;
#define mp make_pair
#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
template<class T1, class T2> inline void chkmin(T1 &a, const T2 &b) {if (a > b) a = b;}
template<class T1, class T2> inline void chkmax(T1 &a, const T2 &b) {if (a < b) a = b;}
const int MAXN = 502;

struct edge
{
	int to;
	int flow;
	int cap;
	edge(){}
	edge(int _to, int _flow, int _cap) {
		to = _to;
		flow = _flow;
		cap = _cap;
	}
};


vector<edge> e;
vector<int> g[MAXN];

void add_edge(int a, int b, int c) {
	e.pb(edge(b, 0, c));
	g[a].pb(sz(e) - 1);
	e.pb(edge(a, 0, 0));
	g[b].pb(sz(e) - 1);
}

int q[MAXN];
int uk = 0;
int ql = 0;
int d[MAXN];
int s, t;
int ptr[MAXN];

void bfs() {
	uk = 0;
	ql = 0;
	for (int i = 0; i <= t; i++) {
		d[i] = -1;
	}
	d[s] = 0;
	q[uk] = s;
	uk++;
	while (ql != uk) {
		int a = q[ql];
		ql++;
		for (auto x: g[a]) {
			if (e[x].cap - e[x].flow > 0) {
				if (d[e[x].to] == -1) {
					d[e[x].to] = d[a] + 1;
					q[uk] = e[x].to;
					uk++;
				}
			}
		}
	}
}



bool used[MAXN];



int dfs(int u, int cur = 1000000000) {
	used[u] = true;
	if (u == t) {
		return cur;
	}
	for (; ptr[u] < sz(g[u]); ptr[u]++) {
		int id = g[u][ptr[u]];
		if (d[e[id].to] != d[u] + 1 || used[e[id].to]) {
			continue;
		} 
		if (e[id].cap - e[id].flow <= 0) {
			continue;
		}
		int f = dfs(e[id].to, min(cur, e[id].cap - e[id].flow));
		if (f) {
			e[id].flow += f;
			e[id ^ 1].flow -= f;
			return f;
		} 
	}
	return 0;
}



int dinic() {
	int flow = 0;
	while (true) {
		bfs();
		if (d[t] == -1) {
			break;
		}
		memset(ptr, 0, sizeof(ptr));
		while (true) {
			memset(used, 0, sizeof(used));
			int k = dfs(s);
			if (k) {
				flow += k;
			} else {
				break;
			}
		}
	}
	return flow;
}



int n, m;
int as[MAXN];
int bs[MAXN];
vector<pair<int, int> > v[MAXN];
bool in[MAXN];


int calc() {
	e.clear();
	for (int i = 0; i <= n + 1; i++) {
		g[i].clear();
	}
	int sum = 0;
	for (int i = 1; i <= n; i++) {
		if (in[i]) {
			add_edge(s, i, bs[i]);
			add_edge(i, t, as[i]);
			sum += as[i] + bs[i];
			for (auto x: v[i]) {
				if (in[x.first]) {
					add_edge(i, x.first, x.second);
				}
			}
		}
	}
	return sum - dinic();
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	cin >> n >> m;
	s = 0;
	t = n + 1;
	for (int i = 1; i <= n; i++) {
		cin >> as[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> bs[i];
		in[i] = true;
	}
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		v[a].pb({b, c});
		v[b].pb({a, c});
	}
	cout << calc() << '\n';
	int qs;
	cin >> qs;
	for (int it = 0; it < qs; it++) {
		int ts;
		cin >> ts;
		if (ts == 1) {
			int x;
			cin >> x;
			in[x] = true;
			cout << calc() << '\n';
		} else if (ts == 2) {
			int x;
			cin >> x;
			in[x] = false;
			cout << calc() << '\n';
		} else if (ts == 3) {
			for (int i = 1; i <= n; i++) {
				in[i] = true;
			}
		} else if (ts == 4) {
			for (int i = 1; i <= n / 5; i++) {
				in[i] = false;
			}
		}
	}
}