#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <string>
#include <cstring>
#include <iomanip>
#include <functional>
#include <numeric>
#include <random>
#include <queue>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#pragma GCC optimize("Ofast")

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int max_n = 205;
const int mx = max_n * max_n * 2;
int n, l, b, k, p, type[mx], deg[mx];
vector<int> g[mx], g_rev[mx];

void add_edge(int u, int v) {
	g[u].push_back(v);
	g_rev[v].push_back(u);
	deg[u]++;
	//cerr << "add_edge " << u << " " << v << endl;
}

void retro() {
	queue<int> q;
	for (int i = 0; i < n - 1; ++i) {
		int p1 = n - 1, p2 = i;
		int v = 2 * n * p1 + 2 * p2;
		type[v] = 1;
		type[v + 1] = 0;
		q.push(v);
		q.push(v + 1);
	}

	for (int i = 0; i < n - 1; ++i) {
		int p1 = i, p2 = n - 1;
		int v = 2 * n * p1 + 2 * p2;
		type[v] = 0;
		type[v + 1] = 1;
		q.push(v);
		q.push(v + 1);
	}

	while (!q.empty()) {
		int v = q.front();
		q.pop();

		if (type[v] == 0) {
			for (auto v1 : g_rev[v]) {
				if (type[v1] == -1) {
					type[v1] = 1;
					q.push(v1);
				}
			}
		}
		else {
			for (auto v1 : g_rev[v]) {
				if (type[v1] == -1) {
					deg[v1]--;
					if (deg[v1] == 0) {
						type[v1] = 0;
						q.push(v1);
					}
				}
			}
		}
	}

	cerr << "pos1" << endl;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cerr << type[i * 2 * n + j * 2] << " ";
		}
		cerr << endl;
	}

	cerr << "pos2" << endl;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cerr << type[i * 2 * n + j * 2 + 1] << " ";
		}
		cerr << endl;
	}
}

int turn1(int i, int j, int step) {
	i += step;
	if (i == j) {
		j = max(j - k, 0);
	}
	return 2 * n * i + 2 * j + 1;
}

int turn2(int i, int j, int step) {
	j += step;
	if (i == j) {
		i = max(i - k, 0);
	}
	return 2 * n * i + 2 * j;
}

void game() {
	cin >> n >> l >> b >> k;

	if (n == 1) {
		cout << "Lora\n";
		return;
	}

	p = 2 * n * n;

	for (int i = 0; i < p; ++i) {
		g[i].clear();
		g_rev[i].clear();
		type[i] = -1;
		deg[i] = 0;
	}

	for (int i = 0; i < n - 1; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			int v = 2 * n * i + 2 * j;
			for (int new_i = i + 1; new_i <= min(n - 1, i + l); ++new_i) {
				add_edge(v, turn1(i, j, new_i - i));
			}
			for (int new_j = j + 1; new_j <= min(n - 1, j + b); ++new_j) {
				add_edge(v + 1, turn2(i, j, new_j - j));
			}
		}
	}

	retro();

	if (type[0] == 0) {
		cout << "Bobi\n";
	}
	if (type[0] == 1) {
		cout << "Lora\n";
	}
	if (type[0] == -1) {
		cout << "Draw\n";
	}
}

signed main() {
	int T;
	cin >> T;
	for (int i = 0; i < T; ++i) {
		game();
	}
}
