#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int MAXN = 1e3 + 5;
int n, m, q;
int s, t;
int a[MAXN];
int b[MAXN];
bool used[MAXN];
int fn;
bool playing[MAXN];
int d[MAXN];
int last[MAXN];
ll res;

struct edge {
    ll to, c, f;
};
vector<edge> e;
vector<int> g[MAXN];

void link(int a, int b, int c) {
    g[a].push_back(e.size());
    e.push_back({b, c, 0});
    g[b].push_back(e.size());
    e.push_back({a, 0, 0});
}

void release() {
    for (auto &it : e) {
        it.f = 0;
    }
}

ll B;

ll dfs(int v, ll cap) {
    if (!cap) return 0;
    if (v == t) return cap;

    for (; last[v] < g[v].size(); ++last[v]) {
        int x = g[v][last[v]];
        if (used[e[x].to] || !playing[e[x].to]) continue;
        if (e[x].c < B) continue;
        if (d[e[x].to] != d[v] + 1) continue;

        ll res = dfs(e[x].to, min(cap, e[x].c - e[x].f));
        if (!res) continue;

        e[x].f += res;
        e[x ^ 1].f -= res;
        return res;
    }

    return 0;
}

bool bfs() {
    fill(d, d + fn, INT_MAX);
    fill(last, last + fn, 0);

    d[s] = 0;
    queue<int> q;
    q.push(s);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto x : g[v]) {
            if (!playing[e[x].to]) continue;
            if (d[e[x].to] != INT_MAX) continue;
            if (e[x].c < B) continue;
            if (e[x].c - e[x].f <= 0) continue;

            d[e[x].to] = d[v] + 1;
            q.push(e[x].to);
        }
    }

    return d[t] != INT_MAX;
}

ll maxflow() {
    ll res = 0;
    for (B = 1LL << 20; B >= 1; B >>= 1) {
        while (bfs()) {
            while (1) {
                ll x = dfs(s, INT_MAX);
                if (!x) break;

                res += x;
            }
        }
    }

    return res;
}

struct event {
    int t, x;
    vector<bool> saved;
};

event ev[int(2e3 + 5)];
vector<ll> ans;
ll cur;

void add(int v) {
    if (playing[v]) return;
    playing[v] = true;
    res += a[v] + b[v];
    cur += maxflow();
}

void alt_solve() {
    for (int id = q; id >= 0; --id) {
        if (ev[id].t == 1) {
            assert(false);
        } else if (ev[id].t == 2) {
            ans.push_back(res - cur);
            add(ev[id].x);
        } else if (ev[id].t == 3) {
            rep(i, n) {
                playing[i] = ev[id].saved[i];
            }
            res = 0;
            for (int i = 0; i < n; ++i) {
                if (!playing[i]) continue;
                res += a[i] + b[i];
            }

            release();
            cur = maxflow();
        } else {    
            rep(x, n / 5) {
                add(x);
            }
        }
    }
    ans.push_back(res - cur);

    reverse(all(ans));
    for (auto it : ans) {
        cout << it << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;

    s = n;
    t = n + 1;
    fn = t + 1;

    res = 0;

    rep(i, n) {
        cin >> a[i];
        link(s, i, a[i]);
        res += a[i];
    }

    rep(i, n) {
        cin >> b[i];
        link(i, t, b[i]);
        res += b[i];
    }

    rep(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;

        // link(a, b, c);
        // link(b, a, c);
        g[a].push_back(e.size());
        e.push_back({b, c, 0});
        g[b].push_back(e.size());
        e.push_back({a, c, 0});
    }

    fill(playing, playing + n + 2, true);

    int cnt1 = 0, cnt3 = 0;
    cin >> q;
    rep(ttt, q) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            x--;
            // if (!playing[x]) res += a[x] + b[x];
            playing[x] = true;

            ev[ttt] = {t, x, {}};
            cnt1++;
        } else if (t == 2) {
            int x;
            cin >> x;
            x--;
            // if (playing[x]) res -= a[x] + b[x];
            playing[x] = false;

            ev[ttt] = {t, x, {}};
        } else if (t == 3) {
            cnt3++;
            ev[ttt] = {t, 0, vector<bool> (playing, playing + n)};

            rep(x, n) {
                // if (!playing[x]) res += a[x] + b[x];
                playing[x] = true;
            }
        } else {
            ev[ttt] = {t, 0, {}};
            for (int x = 0; x < n / 5; ++x) {
                if (playing[x]) res -= a[x] + b[x];
                playing[x] = false;
            }
        }

        // if (t == 1 || t == 2) {
        //     release();
        //     cout << res - maxflow() << '\n';
        // }
    }

    if (cnt1 == 0 && cnt3 <= 10) {
        ev[q] = {3, 0, vector<bool> (playing, playing + n)};
        alt_solve();
        return 0;
    }

    fill(playing, playing + n + 2, true);

    res = 0;
    rep(i, n) {
        res += a[i] + b[i];
    }
    cout << res - maxflow() << '\n';

    rep(id, q) {
        int t = ev[id].t;
        if (t == 1) {
            int x = ev[id].x;
            // cin >> x;
            // x--;
            if (!playing[x]) res += a[x] + b[x];
            playing[x] = true;
        } else if (t == 2) {
            int x = ev[id].x;
            // cin >> x;
            // x--;
            if (playing[x]) res -= a[x] + b[x];
            playing[x] = false;
        } else if (t == 3) {
            // cnt3++;
            // ev[ttt] = {t, 0, vector<bool> (playing, playing + n)};

            rep(x, n) {
                if (!playing[x]) res += a[x] + b[x];
                playing[x] = true;
            }
        } else {
            // ev[ttt] = {t, 0, {}};
            for (int x = 0; x < n / 5; ++x) {
                if (playing[x]) res -= a[x] + b[x];
                playing[x] = false;
            }
        }

        if (t == 1 || t == 2) {
            release();
            cout << res - maxflow() << '\n';
        }
    }
}