#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int MAXN = 1e3 + 5;
int n, m, q;
int s, t;
int a[MAXN];
int b[MAXN];
bool used[MAXN];
int fn;

struct edge {
    ll to, c, f;
};
vector<edge> e;
vector<int> g[MAXN];

void link(int a, int b, int c) {
    g[a].push_back(e.size());
    e.push_back({b, c, 0});
    g[b].push_back(e.size());
    e.push_back({a, 0, 0});
}

void release() {
    for (auto &it : e) {
        it.f = 0;
    }
}

ll B;

ll dfs(int v, ll cap) {
    if (!cap) return 0;
    if (v == t) return cap;

    used[v] = true;
    for (auto x : g[v]) {
        if (used[e[x].to]) continue;
        if (e[x].c < B) continue;

        ll res = dfs(e[x].to, min(cap, e[x].c - e[x].f));
        if (!res) continue;

        e[x].f += res;
        e[x ^ 1].f -= res;
        return res;
    }

    return 0;
}

ll maxflow() {
    ll res = 0;
    for (B = 1LL << 20; B >= 1; B >>= 1) {
        while (1) {
            fill(used, used + fn, false);
            ll x = dfs(s, INT_MAX);
            if (!x) break;

            res += x;
        }
    }

    return res;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;

    s = n;
    t = n + 1;
    fn = t + 1;

    ll res = 0;

    rep(i, n) {
        cin >> a[i];
        link(s, i, a[i]);
        res += a[i];
    }

    rep(i, n) {
        cin >> b[i];
        link(i, t, b[i]);
        res += b[i];
    }

    rep(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;

        // link(a, b, c);
        // link(b, a, c);
        g[a].push_back(e.size());
        e.push_back({b, c, 0});
        g[b].push_back(e.size());
        e.push_back({a, c, 0});
    }

    cout << res - maxflow() << endl;
}