#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

const int MAXN = 1e3 + 5;
int n, m, q;
int s, t;
int a[MAXN];
int b[MAXN];
bool used[MAXN];
int fn;
bool playing[MAXN];
int d[MAXN];
int last[MAXN];

struct edge {
    ll to, c, f;
};
vector<edge> e;
vector<int> g[MAXN];

void link(int a, int b, int c) {
    g[a].push_back(e.size());
    e.push_back({b, c, 0});
    g[b].push_back(e.size());
    e.push_back({a, 0, 0});
}

void release() {
    for (auto &it : e) {
        it.f = 0;
    }
}

ll B;

// ll dfs(int v, ll cap) {
//     if (!cap) return 0;
//     if (v == t) return cap;

//     used[v] = true;
//     for (auto x : g[v]) {
//         if (used[e[x].to] || !playing[e[x].to]) continue;
//         if (e[x].c < B) continue;

//         ll res = dfs(e[x].to, min(cap, e[x].c - e[x].f));
//         if (!res) continue;

//         e[x].f += res;
//         e[x ^ 1].f -= res;
//         return res;
//     }

//     return 0;
// }

ll dfs(int v, ll cap) {
    if (!cap) return 0;
    if (v == t) return cap;

    for (; last[v] < g[v].size(); ++last[v]) {
        int x = g[v][last[v]];
        if (used[e[x].to] || !playing[e[x].to]) continue;
        if (e[x].c < B) continue;
        if (d[e[x].to] != d[v] + 1) continue;

        ll res = dfs(e[x].to, min(cap, e[x].c - e[x].f));
        if (!res) continue;

        e[x].f += res;
        e[x ^ 1].f -= res;
        return res;
    }

    return 0;
}

bool bfs() {
    fill(d, d + fn, INT_MAX);
    fill(last, last + fn, 0);

    d[s] = 0;
    queue<int> q;
    q.push(s);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto x : g[v]) {
            if (!playing[e[x].to]) continue;
            if (d[e[x].to] != INT_MAX) continue;
            if (e[x].c < B) continue;
            if (e[x].c - e[x].f <= 0) continue;

            d[e[x].to] = d[v] + 1;
            q.push(e[x].to);
        }
    }

    return d[t] != INT_MAX;
}

ll maxflow() {
    ll res = 0;
    for (B = 1LL << 20; B >= 1; B >>= 1) {
        while (bfs()) {
            while (1) {
                ll x = dfs(s, INT_MAX);
                if (!x) break;

                res += x;
            }
        }
    }

    return res;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;

    s = n;
    t = n + 1;
    fn = t + 1;

    ll res = 0;

    rep(i, n) {
        cin >> a[i];
        link(s, i, a[i]);
        res += a[i];
    }

    rep(i, n) {
        cin >> b[i];
        link(i, t, b[i]);
        res += b[i];
    }

    rep(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;

        // link(a, b, c);
        // link(b, a, c);
        g[a].push_back(e.size());
        e.push_back({b, c, 0});
        g[b].push_back(e.size());
        e.push_back({a, c, 0});
    }

    fill(playing, playing + n + 2, true);

    cout << res - maxflow() << '\n';

    cin >> q;
    rep(ttt, q) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            x--;
            if (!playing[x]) res += a[x] + b[x];
            playing[x] = true;
        } else if (t == 2) {
            int x;
            cin >> x;
            x--;
            if (playing[x]) res -= a[x] + b[x];
            playing[x] = false;
        } else if (t == 3) {
            rep(x, n) {
                if (!playing[x]) res += a[x] + b[x];
                playing[x] = true;
            }
        } else {
            for (int x = 0; x < n / 5; ++x) {
                if (playing[x]) res -= a[x] + b[x];
                playing[x] = false;
            }
        }

        if (t == 1 || t == 2) {
            release();
            cout << res - maxflow() << '\n';
        }
    }
}