#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

const int INF = 1e9;
const int MOD = 1e9 + 7;
const int P = 41;

namespace limits {
    const int maxN = 1e5;
    const int maxM = 1e5;
    const int maxK = 1e5;
}

struct Edge {
    int to, c;
};

int n, m;
vector<int> cost1, cost2;
vector<vector<Edge>> edges;





int count(bool f, const set<int> &a) {
    vector<int> summ(n);
    vector<bool> iin(n, f);
    int s = 0;
    int dest = 0;

    for (int i : a) {
        s += (iin[i] ? cost1[i] : cost2[i]);
    }
    for (int i : a) {
        for (Edge e : edges[i]) {
            if (a.find(e.to) != a.end()) {
                summ[i] += e.c;
            }
        }
    }
    bool change = true;
    while (change) {
        change = false;
        for (int i : a) {
            if (summ[i] < (iin[i] ? cost2[i] - cost1[i] : cost1[i] - cost2[i])) {
                change = true;

                dest += summ[i];
                s += (iin[i] ? cost2[i] - cost1[i] : cost1[i] - cost2[i]);
                summ[i] = 0;
                for (Edge e : edges[i]) {
                    if (a.find(e.to) != a.end()) {
                        if (iin[i] == iin[e.to]) {
                            summ[i] -= e.c;
                            summ[e.to] -= e.c;
                        } else {
                            summ[i] += e.c;
                            summ[e.to] += e.c;
                        }
                    }
                }
                iin[i] = !iin[i];
            }
        }
    }
    return s - dest;
}

int cnt(const set<int> &a) {
    return max(count(true, a), count(false, a));
}

int32_t main()
{
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    cin.sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    edges.resize(n);
    cost1.resize(n);
    cost2.resize(n);

    for (int &c : cost1) {
        cin >> c;
    }

    for (int &c : cost2) {
        cin >> c;
    }

    int x, y, c;
    for (int i = 0; i < m; i++) {
        cin >> x >> y >> c;
        x--;
        y--;
        edges[x].push_back({y, c});
        edges[y].push_back({x, c});
    }

    set<int> s1, s2;

    for (int i = 0; i < n; i++) {
        s1.insert(i);
    }

    cout << cnt(s1) << endl;

    int q;
    cin >> q;
    int t;
    for (int i = 0; i < q; i++) {
        cin >> t;
        switch (t) {
            case 1 : {
                cin >> x;
                x--;
                s2.erase(x);
                s1.insert(x);
                cout << cnt(s1) << endl;
                break;
            }
            case 2 : {
                cin >> x;
                x--;
                s1.erase(x);
                s2.insert(x);
                cout << cnt(s1) << endl;
                break;
            }
            case 3 : {
                s1.clear();
                s2.clear();
                for (int i = 0; i < n; i++) {
                    s1.insert(i);
                }
                break;
            }
            case 4 : {
                for (int i = 0; i < n / 5; i++) {
                    s1.erase(i);
                    s2.insert(i);
                }
                break;
            }
        }
    }

    return 0;
}
