#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

const int INF = 1e9;
const int MOD = 1e9 + 7;
const int P = 41;

namespace limits
{
const int maxN = 1e5;
const int maxM = 1e5;
const int maxK = 1e5;
}

const int Lo = 0;
const int Bo = 1;
const int D = 2;


struct state
{
    int LN, BN, L, B, K;
    bool Lturn;

    friend bool operator<(const state &a, const state &b)
    {
        return a.LN < b.LN;
    }
};

map<state, int> cache;
set<state> was;

int cached(state s, int ans)
{
    cache[s] = ans;
    return ans;
}

state forwardL(state s)
{
    return {s.LN - s.L, s.BN, s.L, s.B, s.K, !s.Lturn};
}

state forwardB(state s)
{
    return {s.LN, s.BN - s.B, s.L, s.B, s.K, !s.Lturn};
}

state chL(state s)
{
    if (s.LN - s.BN > s.L || s.LN <= s.BN)
    {
        return forwardL(s);
    }
    return {s.BN, s.BN + s.K, s.L, s.B, s.K, !s.Lturn};
}

state chB(state s)
{
    if (s.BN - s.LN > s.B || s.BN <= s.LN)
    {
        return forwardB(s);
    }
    return {s.LN + s.K, s.LN, s.L, s.B, s.K, !s.Lturn};
}

int best(int o, int a, int b)
{
    if (a == o || b == o)
    {
        return o;
    }
    if (a == D || b == D)
    {
        return D;
    }
    return a;
}

int solve(state s)
{
    if (cache.find(s) != cache.end())
        return cache[s];
    if (s.LN <= 0)
        return cached(s, Lo);
    if (s.BN <= 0)
    {
        return cached(s, Bo);
    }
    if (was.find(s) != was.end())
    {
        return (s.Lturn ? Bo : Lo);
    }
    was.insert(s);
    if (s.Lturn)
    {
        if (s.LN - s.L > s.BN)
        {
            return Bo;
        }
        return cached(s, best(Lo, solve(forwardL(s)), solve(chL(s))));
    }
    else
    {
        if (s.BN - s.B > s.LN)
        {
            return Lo;
        }
        return cached(s, best(Bo, solve(forwardB(s)), solve(chB(s))));
    }
}

int solve(int N, int L, int B, int K)
{
    N--;
    if (L >= N)
    {
        return Lo;
    }
    if (B >= N)
    {
        return Bo;
    }
    if (L > B)
    {
        return Lo;
    }
    if (L == B)
    {
        if (K == L)
        {
            return D;
        }
    }
    else
    {
        if (B > L + K )
        {
            return Bo;
        }
    }
    return solve({N, N, L, B, K, true});
}



int32_t main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    int N, L, B, K;
    for (int i = 0; i < T; i++)
    {
        cin >> N >> L >> B >> K;
        switch (solve(N, L, B, K))
        {
        case Lo :
        {
            cout << "Lora\n";
            break;
        }
        case Bo :
        {
            cout << "Bobi\n";
            break;
        }
        default :
        {
            cout << "Draw\n";
            break;
        }
        }
    }

    return 0;
}
