#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int N = 1005, M = 1e6, INF = 1e9;
int cp[M], fl[M], p[N], d[N], a[N], b[N];
bool out[N];
int z = 0;
int n, m, s, t;
vector<pair<int, int>> v[N];

int bfs() {
    queue<int> q;
    q.push(s);
    fill(d, d + n + 2, -1);
    d[s] = 0;

    while (!q.empty()) {
        int node = q.front();
        q.pop();

        for (auto p : v[node]) {
            if (!out[p.first] && cp[p.second] > fl[p.second] && d[p.first] == -1) {
                d[p.first] = d[node] + 1;
                q.push(p.first);
            }
        }
    }

    return d[t] != -1;
}

void addEdge(int a, int b, int c, int d = 0) {
    cp[z] = c;
    v[a].push_back({b, z++});
    cp[z] = d;
    v[b].push_back({a, z++});
}

int dfs(int node, int flow) {
    if (!flow)
        return 0;
    if (node == t) {
        return flow;
    }

    for (int &i = p[node]; i < v[node].size(); i++) {
        int to = v[node][i].first, num = v[node][i].second;
        if (!out[to] && d[to] == d[node] + 1) {
            int ret = dfs(to, min(flow, cp[num] - fl[num]));
            if (ret) {
                fl[num] += ret;
                fl[num ^ 1] -= ret;
                return ret;
            }
        }
    }
    return 0;
}
int maxFlow() {
    int flow = 0;
    while (bfs()) {
        fill(p, p + n + 2, 0);
        int ret = dfs(s, INF);
        while (ret) {
            flow += ret;
            ret = dfs(s, INF);
        }
    }
    return flow;
}

int getAns() {
    int sum = 0;

    for (int i = 0; i < n; i++) {
        if (out[i])
            continue;
        if (a[i] >= b[i]) {
            sum += a[i];
            addEdge(s, i, a[i] - b[i]);
        }
        else {
            sum += b[i];
            addEdge(i, t, b[i] - a[i]);
        }
    }

    sum -= maxFlow();

    fill(fl, fl + z, 0);

    for (int i = 0; i < n; i++) {
        if (out[i])
            continue;
        if (a[i] >= b[i]) {
            v[s].pop_back();
            v[i].pop_back();
            z -= 2;
        }
        else {
            v[i].pop_back();
            v[t].pop_back();
            z -= 2;
        }
    }

    return sum;
}

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // HOME

    scanf("%d%d", &n, &m);

    s = n;
    t = n + 1;

    for (int i = 0 ; i < n; i++) {
        scanf("%d", &a[i]);
    }
    for (int i = 0 ; i < n; i++) {
        scanf("%d", &b[i]);
    }

    for (int i = 0; i < m; i++) {
        int a, b, c;
        scanf("%d%d%d", &a, &b, &c);
        a--, b--;
        addEdge(a, b, c, c);
    }



    printf("%d\n", getAns());

    int q;
    scanf("%d", &q);

    for (int i = 0; i < q; i++) {
        int x, y;
        scanf("%d", &x);
        if (x == 1) {
            scanf("%d", &y);
            out[y - 1] = 0;
        }
        else if (x == 2) {
            scanf("%d", &y);
            out[y - 1] = 1;
        }
        else if (x == 3) {
            for (int j = 0; j < n; j++)
                out[j] = 0;
        }
        else {
            for (int j = 0; j < n / 5; j++)
                out[j] = 1;
        }

        if (x <= 2)
            printf("%d\n", getAns());
    }


    return 0;
}
