#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define f first
#define s second
#define mp(a, b) make_pair(a, b)

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // HOME

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    exit(0);
}


int get(set<int> &in_game, vector<int> &good, vector<int> &bad, vector<pair<pair<int, int>, int>> &cost) {
    vector<int> ppl;
    for (auto it: in_game) {
        ppl.push_back(it);
    }

    int best = 0;
    for (int mask = 0; mask < (1 << size(ppl)); mask++) {
        int now = 0;
        for (auto i: ppl) {
            if ((mask >> i) & 1) {
                now += good[i];
            } else {
                now += bad[i];
            }
        }

        for (int i = 0; i < size(cost); i++) {
            if (in_game.count(cost[i].f.f) && in_game.count(cost[i].f.s) && ((mask >> cost[i].f.f) & 1) != ((mask >> cost[i].f.s) & 1)) {
                now -= cost[i].s;
            }
        }

        best = max(best, now);
//        if (best == now) cout << best << "=" << mask << "\n";
    }

    return best;
}


void solve()
{
    int n, m;
    cin >> n >> m;

    vector<int> good(n);
    for (int i = 0; i < n; i++) {
        cin >> good[i];
    }

    vector<int> bad(n);
    for (int i = 0; i < n; i++) {
        cin >> bad[i];
    }

    vector<pair<pair<int, int>, int>> cost(m);

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        cost[i] = mp(mp(--a, --b), c);
    }

    int q;
    cin >> q;

    set<int> in_game;
    for (int i = 0; i < n; i++) {
        in_game.insert(i);
    }

    cout << get(in_game, good, bad, cost) << "\n";

    while (q--) {
        int t;
        cin >> t;

        if (t == 2) {
            int x;
            cin >> x;
            in_game.erase(--x);
        }
        if (t == 1) {
            int x;
            cin >> x;
            in_game.insert(--x);
        }
        if (t == 3) {
            for (int i = 0; i < n; i++) {
                in_game.insert(i);
            }
        }
        if (t == 4) {
            int to = n / 5;
            while (*in_game.begin() < to) {
                in_game.erase(in_game.begin());
            }
        }

        if (t < 3) cout << get(in_game, good, bad, cost) << "\n";
    }
}
